var folders    = window.arguments[0].inn.folders;
var folderTree = window.arguments[0].inn.folderTree;

var SimpleMailArchive = {
  initialize: function() {
    simplemail.SimpleMailOverlay = simplemail.SimpleMailUtils.getBrowserWindow().simplemail.SimpleMailOverlay;
    SimpleMailArchive.populateAccountId();
    var today = new Date();
    simplemail.SimpleMailPrefs.setString('dateValue', SimpleMailArchive.initialize.today);
    simplemail.SimpleMailDom.get("accountId").selectedIndex=0;
  },

  choice: function(selectedIndex) {
    if (simplemail.SimpleMailDom.get("choice").selectedIndex == 0) {
     simplemail.SimpleMailDom.get("accountId").disabled = false;
    }  
    else if (simplemail.SimpleMailDom.get("choice").selectedIndex == 1){
      simplemail.SimpleMailDom.get("accountId").disabled = true;
    }
  },

  archiveType: function(selectedIndex) {
    if (simplemail.SimpleMailDom.get("archiveType").selectedIndex == 1) {
      simplemail.SimpleMailDom.get('deletemessages').checked = false;
      simplemail.SimpleMailDom.get("deletemessages").disabled = true;
    } else {
      simplemail.SimpleMailDom.get("deletemessages").disabled = false;
    }
  },

  browseDataDirectory: function() {
    var file = simplemail.SimpleMailFile.chooseFile("folder");
    if (file) {
      simplemail.SimpleMailDom.get("dataDirectory").value = file.path;
      simplemail.SimpleMailPrefs.setString("dataDirectory", file.path);
    }
  },

  populateAccountId: function() {
    var taccounts = simplemail.SimpleMailOverlay.storage.getAccounts();
    var popup     = simplemail.SimpleMailDom.get("accountId").menupopup;

    for (var i = 0; i < taccounts.length; i++) {
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("label", taccounts[i]);
      menuitem.setAttribute("value", taccounts[i].id);
      popup.appendChild(menuitem);
    }
    popup.parentNode.selectedIndex = 0;
  },

  updateWindow: function() {
    if ((simplemail.SimpleMailDom.get("archiveType").selectedIndex == 1)) {
      var archiveType = simplemail.SimpleMailDom.get("archiveType").selectedIndex;
      window.arguments[0].out = {archiveType:archiveType};
      close();
    } else {
      close();
    }
  },

  next: function() {
    var deck  = simplemail.SimpleMailDom.get("stateDeck");
    var index = deck.getAttribute("selectedIndex");
    switch (index) {
      case "0":
        deck.setAttribute("selectedIndex", "1");
      case "1":
        SimpleMailArchive.okDialog();
        break;
      case "2":
        SimpleMailArchive.updateWindow();
        break;  
    }
  },

  okDialog: function() {
    //console.error("SM.okDialog", simplemail.SimpleMailDom.get("archiveType").selectedIndex, this);//userok_log
    
    if (simplemail.SimpleMailDom.get("archiveType").selectedIndex == 1) {
      SimpleMailArchive.outputFolder(function(Result) {
        //console.error("SM.outputFolder", Result, this);//userok_log
        if (Result)
          SimpleMailArchive.ShowResults(true);
        else {
          SimpleMailArchive.setProgress(5);
          SimpleMailArchive.ShowResults(false);
        }
      });
      return;
    }

    if (SimpleMailArchive.outputFile() == true) {
      SimpleMailArchive.ShowResults(true);
      return true;
    } else {
      SimpleMailArchive.setProgress(5);
      return false;
    }
    SimpleMailArchive.ShowResults(false);
  },

  setProgress: function(pct) {
    if (pct <= 100) {
      var progressMeter = simplemail.SimpleMailDom.get("progressMeter");
      progressMeter.value =  pct;
    }
    
    return; 
  },

  attachStrings: function(aNode, aString) {
    var attachNode = simplemail.SimpleMailDom.get(aNode);
    var strings = aString.split("\n");

    for (var i = 0; i < strings.length; i++) {
      if (strings[i]) {
        var currNode = document.createTextNode(strings[i]);
        attachNode.appendChild(currNode);
        var br = document.createElementNS("http://www.w3.org/1999/xhtml", 'br');
        attachNode.appendChild(br);
      }
    }
  },

  ShowResults: function(good) {
    var result;

    if (good)
      result = simplemail.SimpleMailBundle.getString("createdArchive")
    else
      result = simplemail.SimpleMailBundle.getString("errorArchive");

    SimpleMailArchive.attachStrings("results", result);
    var deck = simplemail.SimpleMailDom.get("stateDeck");
    deck.setAttribute("selectedIndex", "2");
    var nextButton = simplemail.SimpleMailDom.get("next");
    nextButton.label = nextButton.getAttribute("finishedval");
    nextButton.removeAttribute("disabled");
    var cancelButton = simplemail.SimpleMailDom.get("cancel");
    cancelButton.setAttribute("hidden", "true");
  },

  getString: function(statement, id) {
    var text = "text: ";
    var value = statement.getString(id);
    return value && value.substr(0, text.length) == text ? value.substr(text.length) : value;
  },

  outputFile: function() {
    var deck = simplemail.SimpleMailDom.get("stateDeck");
    var dateValue = new Date(simplemail.SimpleMailPrefs.getString('dateValue'));
    if (new Date(simplemail.SimpleMailPrefs.getString('dateValue')) > SimpleMailArchive.initialize.today ){
      var confirmText = simplemail.SimpleMailBundle.getString("archiveAlert");
        if (!simplemail.SimpleMailUtils.confirm(confirmText)) {
          deck.setAttribute("selectedIndex", "0");
          return;
        }
     }

    // Get msgs for account   
    if (simplemail.SimpleMailDom.get("choice").selectedIndex == 0) {
      var selectedAccount = simplemail.SimpleMailDom.get("accountId").selectedItem.value;
      var Accountlabel = simplemail.SimpleMailDom.get("accountId").selectedItem.label;
      var Accountlabel = Accountlabel.replace(/(<).*?/g,"(");
      var Accountlabel = Accountlabel.replace(/(>).*?/g,")"); 
       
      var msg          = [];  
      var msg          = simplemail.SimpleMailOverlay.storage.getAccountMessages(selectedAccount);
      var messagesDate = [];
      for (var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date) < dateValue)
          messagesDate.push(msg[i]);
      }
    } else {
      // Get msgs for selected folder
      var folder = window.arguments[0].inn.folder;
      // Get msgs in subfolders
      var msg = [];
      simplemail.SimpleMailManageFolder.forEachFolder(folder, function(f) {
        msg = msg.concat(simplemail.SimpleMailOverlay.storage.getFolderMessages(f.id));
      });

      var messagesDate = [];
      for (var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date) < dateValue)
          messagesDate.push(msg[i]);
      }
    }
    SimpleMailArchive.setProgress(10);

    // Check if messages exists 
    if (msg.length < 1 || messagesDate.length < 1) {
      var confirmText = simplemail.SimpleMailBundle.getString("nomailAlert");
      simplemail.SimpleMailUtils.alert(confirmText);
      deck.setAttribute("selectedIndex", "0");
      return;
    }

    // Create file    
    if ((simplemail.SimpleMailDom.get("archiveType").selectedIndex == 0)) {
      var file = Components.classes["@mozilla.org/file/directory_service;1"]
                 .getService(Components.interfaces.nsIProperties)
                 .get("TmpD", Components.interfaces.nsIFile);
      file.append("simplemail.tmp");
      file.createUnique(file.NORMAL_FILE_TYPE, 0666);
      if (!file) {
        deck.setAttribute("selectedIndex", "0");
        return;
      }
    } else if ((simplemail.SimpleMailDom.get("archiveType").selectedIndex == 1)) {
      SimpleMailArchive.outputFolder();
      if (!file) {
        deck.setAttribute("selectedIndex", "0");
        return;
      }
    } else if ((simplemail.SimpleMailDom.get("choice").selectedIndex == 0) && (simplemail.SimpleMailDom.get("archiveType").selectedIndex == 2)) {
      var date = simplemail.SimpleMailDate.toShortString(dateValue);
      var date = date.replace(/\//g,"-");  
      var file = simplemail.SimpleMailFile.chooseFile("save", [], Accountlabel+" - "+date);
      if (!file) {
        deck.setAttribute("selectedIndex", "0");
        return;
      }
    } else if ((simplemail.SimpleMailDom.get("choice").selectedIndex == 1) && (simplemail.SimpleMailDom.get("archiveType").selectedIndex == 2)) {
      var date = simplemail.SimpleMailDate.toShortString(dateValue);
      var date = date.replace(/\//g,"-");  
      var file = simplemail.SimpleMailFile.chooseFile("save", [], folder.getName()+" - "+date);
      if (!file) {
        deck.setAttribute("selectedIndex", "0");
        return;
      } 
    }

    var out = simplemail.SimpleMailFile.createOutputStream(file);
    SimpleMailArchive.setProgress(20);

    // Write file
    for(var i = msg.length - 1; i >= 0; i--) {
      if ((msg[i].date)< dateValue) {
        var source = simplemail.SimpleMailFile.getAttachmentsDirectory(msg[i].attachmentsDir);
        source.append(simplemail.SimpleMailFile.MESSAGE_SOURCE);
        out.write("From - " + new Date(msg[i].date) + "\r\n");
        out.write(simplemail.SimpleMailFile.readFile(source) + "\r\n\r\n");
        SimpleMailArchive.setProgress(30);
      }
    }
    out.close();
    SimpleMailArchive.setProgress(40);

    // Zip file
    if (simplemail.SimpleMailDom.get("archiveType").selectedIndex == 0) {
      var PR_RDWR        = 0x04
  	  var PR_CREATE_FILE = 0x08
  	  var PR_TRUNCATE    = 0x20
  	  var COMPRESSION_BEST    = 9;
      var zipWriter = Components.Constructor("@mozilla.org/zipwriter;1","nsIZipWriter");
      var zipW = new zipWriter();
      var date = simplemail.SimpleMailDate.toShortString(dateValue);
      var date = date.replace(/\//g,"-"); 

      if (simplemail.SimpleMailDom.get("choice").selectedIndex == 0){
        var out = simplemail.SimpleMailFile.chooseFile("save", ["*.zip"], Accountlabel+" - "+date+".zip");
        if (!out) {
          deck.setAttribute("selectedIndex", "0");
          file.remove(true);
          return;
        }
      } else {
        var out = simplemail.SimpleMailFile.chooseFile("save", ["*.zip"], folder.getName()+" - "+date+".zip");
        if (!out) {
          deck.setAttribute("selectedIndex", "0");
          file.remove(true);
          return;
        } 
      }

      var zipfile = simplemail.SimpleMailFile.getNsiFile(out);
      var file = simplemail.SimpleMailFile.getNsiFile(file);

      zipW.open(zipfile, PR_RDWR | PR_CREATE_FILE | PR_TRUNCATE);

      var path = out.leafName.slice(0, -4);
      SimpleMailArchive.setProgress(50);
      zipW.addEntryFile(path, Components.interfaces.nsIZipWriter.COMPRESSION_BEST, file, false);
      zipW.close();
      file.remove(true);
      SimpleMailArchive.setProgress(60);
    }
    SimpleMailArchive.setProgress(70);

    // Delete messages
    if (simplemail.SimpleMailDom.get('deletemessages').checked) {
      var msgs = [];
      for (var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date) < dateValue)
          msgs.push(msg[i]);
      }
      var confirmText = simplemail.SimpleMailBundle.getString("deleteMessages");
      simplemail.SimpleMailOverlay.askDeleteMail(msgs, confirmText, window);
      SimpleMailArchive.setProgress(80);
    }
    SimpleMailArchive.setProgress(90);
    
    return true;
  },

  // Archive in folder // userok: async
  outputFolder: function(callBackDone) {
    var deck      = simplemail.SimpleMailDom.get("stateDeck");
    var dateValue = new Date(simplemail.SimpleMailPrefs.getString('dateValue'));
    if (new Date(simplemail.SimpleMailPrefs.getString('dateValue')) > SimpleMailArchive.initialize.today) {
      if (!simplemail.SimpleMailUtils.confirm(simplemail.SimpleMailBundle.getString("archiveAlert"))) {
        deck.setAttribute("selectedIndex", "0");
        if (callBackDone)
          callBackDone(false);
        return;
      }
    }
    // Get msgs for account   
    if (simplemail.SimpleMailDom.get("choice").selectedIndex == 0) {
      var selectedAccount = simplemail.SimpleMailDom.get("accountId").selectedItem.value;
      var Accountlabel = simplemail.SimpleMailDom.get("accountId").selectedItem.label;
      var Accountlabel = Accountlabel.replace(/(<).*?/g,"(");
      var Accountlabel = Accountlabel.replace(/(>).*?/g,")");
      var msg = [];  
      var msg = simplemail.SimpleMailOverlay.storage.getAccountMessages(selectedAccount);
      
      var messagesDate = [];
      for (var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date) < dateValue)
          messagesDate.push(msg[i]);
      }
    } else {
      // Get msgs for selected folder
      var folder = window.arguments[0].inn.folder;
      // Get msgs in subfolders
      var msg = [];
      simplemail.SimpleMailManageFolder.forEachFolder(folder, function(f) {
        msg = msg.concat(simplemail.SimpleMailOverlay.storage.getFolderMessages(f.id));
      });
      
      var messagesDate = [];
      for (var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date) < dateValue)
          messagesDate.push(msg[i]);
      }
    }
    SimpleMailArchive.setProgress(10);

    // Check if messages exists 
    if (msg.length < 1 || messagesDate.length < 1) {
      simplemail.SimpleMailUtils.alert(simplemail.SimpleMailBundle.getString("nomailAlert"));
      deck.setAttribute("selectedIndex", "0");
      if (callBackDone)
        callBackDone(false);
      return;
    }

    // Create folder
    var name = {};
    if (simplemail.SimpleMailUtils.prompt("folderName", name) && name.value) {
      // Check if Archives folder exist
      var archiveFolder = name.value;
      simplemail.SimpleMailOverlay.storage.getFoldersForArchive(function(foldersNames) { // userok: async
        for (var i = foldersNames.length - 1; i >= 0; i--) {
          if (foldersNames[i] == archiveFolder) {
            simplemail.SimpleMailUtils.alert(simplemail.SimpleMailBundle.getString("alreadyExist"));
            deck.setAttribute("selectedIndex", "0");
            if (callBackDone)
              callBackDone(false);
            return;
          }
        }
        SimpleMailArchive.setProgress(20);
        // Write Folder
        var folderA     = new simplemail.SimpleMailModel.SimpleMailFolder(null, null, archiveFolder);
        folderTree      = window.arguments[0].inn.folderTree;
        folderTree.view = simplemail.folderTreeView; 
        simplemail.SimpleMailManageFolder.setFolderParent(function(fldr, pid) {
          SimpleMailArchive.setProgress(60);
          // Move Messages
          for (var i = msg.length - 1; i >= 0; i--) {
            if ((msg[i].date) < dateValue) {
              msg[i].folderId = fldr.id;
              simplemail.SimpleMailOverlay.storage.saveMessageState(msg[i]);
            } 
          }
          SimpleMailArchive.setProgress(90);    
          // good
          if (callBackDone)
            callBackDone(true);          
        }, folderA, 0);
      });
    } else {
      deck.setAttribute("selectedIndex", "0");
      if (callBackDone)
        callBackDone(false);      
    }
  },

  onClose: function() {
    simplemail.SimpleMailPrefs.clear('dateValue');
  }
}