if (typeof(simplemail) == "undefined" ) {simplemail = {};};

simplemail.SimpleMailPrefs = function(){
  var pub = {};
  
  pub.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.simplemail."),

  pub.getInt = function(name) {
    try {
      return this.prefs.getIntPref(name);
    } catch(e) {
      return 0;
    }
  },

  pub.setInt = function(name, value) {
    this.prefs.setIntPref(name, value);
  },

  pub.getString = function(name) {
    try {
      return this.prefs.getComplexValue(name,
        Components.interfaces.nsISupportsString).data;
    } catch(e) {
      return null;
    }
  },

  pub.setString = function(name, value) {
    var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    str.data = value;
    this.prefs.setComplexValue(name, Components.interfaces.nsISupportsString, str);
  },

  pub.getBool = function(name) {
    try {
      return this.prefs.getBoolPref(name);
    } catch(e) {
      return false;
    }
  },

  pub.setBool = function(name, value) {
    this.prefs.setBoolPref(name, value);
  },

  pub.getObject = function(name) {
    var jsonString = this.getString(name);
    // to match with prefs wrote by SimpleMail version with eval()
    /*if (jsonString !== null) {
      jsonString = jsonString.replace(/\'/g, "\"");
      jsonString = jsonString.replace(/[\(\)]/g, "");
    }*/
    var jsObject = JSON.parse(jsonString);
    return jsObject;
  },

  pub.setObject = function(name, value) {
    this.setString(name, simplemail.SimpleMailUtils.toJSON(value));
  },

  pub.delete = function(name) {
    try {
      if (name) this.prefs.deleteBranch(name);
    } catch(e) {}
  },

  pub.clear = function(name) {
    try {
      if (name) this.prefs.clearUserPref(name);
    } catch(e) {}
  }
  
  return pub;
}();

simplemail.SimpleMailFile = function() {
  var pub = {};
  
  pub.MESSAGE_SOURCE = "message.txt",

  pub.getDataDirectory = function() {
    var dirLocation;
    try {
      dirLocation = simplemail.SimpleMailPrefs.prefs.getComplexValue("dataDirectory", Components.interfaces.nsIRelativeFilePref).file;
    }
    catch(e) {
      dirLocation = simplemail.SimpleMailPrefs.prefs.getComplexValue("dataDirectory", Components.interfaces.nsIFile);
    }
    if (!dirLocation.exists()) dirLocation.create(dirLocation.DIRECTORY_TYPE, 0777);
    return dirLocation;
  },

  pub.getExtensionDirectory = function() { //userok: ugly proc
    var id = "simplemail@telega.phpnet.us";
    //userok: drop very old
    //userok if (typeof(Components.classes["@mozilla.org/extensions/manager;1"]) !== 'undefined')   {
    //userok   dirLocation = Components.classes["@mozilla.org/extensions/manager;1"]
    //userok   .getService(Components.interfaces.nsIExtensionManager).getInstallLocation(id).getItemLocation(id);
    //userok   return dirLocation;
    //userok }
    Components.utils.import("resource://gre/modules/AddonManager.jsm");
    AddonManager.getAddonByID(id, function(addon) {
      dirLocation = addon.getResourceURI("").QueryInterface(Components.interfaces.nsIFileURL).file;
      //console.error("SM.getExtensionDirectory: ", dirLocation.path);//userok_log
    });
  },         
  
  pub.getSmilesDirectory = function() { //userok: ugly proc
    var id = "simplemail@telega.phpnet.us";
    //userok: drop very old
    //userok if (typeof(Components.classes["@mozilla.org/extensions/manager;1"]) !== 'undefined')   {
    //userok   dirLocation = Components.classes["@mozilla.org/extensions/manager;1"]
    //userok         .getService(Components.interfaces.nsIExtensionManager).getInstallLocation(id).getItemLocation(id);
    //userok } else
    //userok if (typeof(Components.utils) !== 'undefined' && typeof(Components.utils.import) !== 'undefined') {
    Components.utils.import("resource://gre/modules/AddonManager.jsm");
    AddonManager.getAddonByID(id, function(addon) {
      dirLocation = addon.getResourceURI("").QueryInterface(Components.interfaces.nsIFileURL).file;
      //console.error("SM.getSmilesDirectory1: ", dirLocation.path);//userok_log
    });
    //userok }
    dirLocation.append("chrome");
    dirLocation.append("skin");
    dirLocation.append("smiles");
    //console.error("SM.getSmilesDirectory2: ", dirLocation.path);//userok_log
    return dirLocation;
  },

  pub.getEnvDirectory = function() { //userok: ugly proc
    var id = "simplemail@telega.phpnet.us";
    //userok: drop very old
    //userok if (typeof(Components.classes["@mozilla.org/extensions/manager;1"]) !== 'undefined')   {
    //userok   dirLocation = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).getInstallLocation(id).getItemLocation(id);
    //userok } else 
    //userok if (typeof(Components.utils) !== 'undefined' && typeof(Components.utils.import) !== 'undefined') {
    Components.utils.import("resource://gre/modules/AddonManager.jsm");
    AddonManager.getAddonByID(id, function(addon) {
      dirLocation = addon.getResourceURI("").QueryInterface(Components.interfaces.nsIFileURL).file;
      //console.error("SM.getEnvDirectory1: ", dirLocation.path);//userok_log
    });
    //userok }
    dirLocation.append("chrome");
    dirLocation.append("skin");
    dirLocation.append("envelope");
    //console.error("SM.getEnvDirectory2: ", dirLocation.path);//userok_log
    return dirLocation;
  },

  pub.getDirectory = function() {
    var dirLocation = simplemail.SimpleMailFile.getDataDirectory();
    for(var i = 0; i < arguments.length; i++) {
      dirLocation.append(arguments[i]);
      if (!dirLocation.exists()) dirLocation.create(dirLocation.DIRECTORY_TYPE, 0777);
    }
    return dirLocation;
  },

  pub.encodeURI = function(url) {
    return encodeURI(url).replace(/'/g, "%27");
  },

  pub.getURL = function() {
    var url = "";
    for(var i = 0; i < arguments.length; i++) {
      url += (url ? "/" : "") + arguments[i];
    }
    return simplemail.SimpleMailFile.encodeURI("simplemail://" + url);
  },

  pub.getAttachmentsDirectory = function(directory) {
    return simplemail.SimpleMailFile.getDirectory("attachments", directory);
  },

  pub.saveAttachment = function(directory, name, contents) {
    var file = simplemail.SimpleMailFile.getAttachmentsDirectory(directory);
    file.append(name);
    simplemail.SimpleMailFile.writeFile(file, contents);
  },

  pub.deleteAttachments = function(directory) {
    if (!directory) return;

    var file = simplemail.SimpleMailFile.getAttachmentsDirectory(directory);
    if (file.exists()) {
      try { file.remove(true); } catch(e) {throw e}
    }
  },

  pub.getAttachmentURL = function(directory, name) {
    return simplemail.SimpleMailFile.getURL("attachments", directory, name);
  },

  pub.getImagesDirectory = function() {
    return simplemail.SimpleMailFile.getDirectory("images");
  },

  pub.deleteImage = function(name) {
    var file = simplemail.SimpleMailFile.getImagesDirectory();
    file.append(name);
    try { file.remove(false); } catch(e) {}
  },
/* userok: not used
  pub.saveUrl = function(url, file) {
    var io = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var source = io.newURI(url, "UTF-8", null);
      
    var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
                            .createInstance(Components.interfaces.nsIWebBrowserPersist);
    
    persist.persistFlags = persist.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
    persist.persistFlags |= persist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
    // Add
    var privacyContext = sourceWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                                     .getInterface(Components.interfaces.nsIWebNavigation)
                                     .QueryInterface(Components.interfaces.nsILoadContext);
                                     
    persist.saveURI(source, null, null, null, null, file, privacyContext);
  },

  pub.saveCanvas = function(canvas, fileName) {
    var file = simplemail.SimpleMailFile.getImagesDirectory();
    file.append(fileName);
    simplemail.SimpleMailFile.saveUrl(canvas.toDataURL("image/png"), file);
  },
*/  
 pub.createOutputStream = function(file) {
    var stream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                 .createInstance(Components.interfaces.nsIFileOutputStream);
    stream.init(file, 0x04 | 0x08 | 0x20, 0666, 0); // Read & write, create, truncate
    var buffered = Components.classes["@mozilla.org/network/buffered-output-stream;1"]
                   .createInstance(Components.interfaces.nsIBufferedOutputStream);
    buffered.init(stream, 1*1024*1024);
    return { stream: stream,
             buffered: buffered,
             write: function(data) {
               this.buffered.write(data, data.length);
             },
             close: function() {
               this.buffered.close();
               this.stream.close();
             }
           };
  },
  
  pub.createOutputStream2 = function(file) {
    var stream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                 .createInstance(Components.interfaces.nsIFileOutputStream);
    stream.init(file, 0x04 | 0x08 | 0x10, 0666, 0); // Read & write, create, truncate
    var buffered = Components.classes["@mozilla.org/network/buffered-output-stream;1"]
                   .createInstance(Components.interfaces.nsIBufferedOutputStream);
    buffered.init(stream, 1*1024*1024);
    return { stream: stream,
             buffered: buffered,
             write: function(data) {
               this.buffered.write(data, data.length);
             },
             close: function() {
               this.buffered.close();
               this.stream.close();
             }
           };
  },  

  pub.createUnicharOutputStream = function(file) {
    var stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    stream.init(file, 0x04 | 0x08 | 0x20, 0666, 0); // Read & write, create, truncate
    var unichar = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
    unichar.init(stream, "utf-8", 0, 0xFFFD);

    return { stream: stream,
             unichar: unichar,
             write: function(data) {
               this.unichar.writeString(data);
             },
             close: function() {
               this.unichar.close();
               this.stream.close();
             }
           };
  },

  pub.createInputStream = function(file) {
    //console.error("SM.file_createInputStream", file, this); //userok_log
    
    var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
    var binary = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream); 
    
    stream.init(file, 0x01, 0444, null);
    binary.setInputStream(stream);

    return { stream: stream,
             binary: binary, 
             readFully: function() {
               return this.binary.readBytes(this.binary.available());
             },
             close: function() {
               this.binary.close();
               this.stream.close();
             }
           };
  },

  pub.createUnicharInputStream = function(file) {
    var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
    var unichar = Components.classes["@mozilla.org/intl/converter-input-stream;1"].createInstance(Components.interfaces.nsIConverterInputStream);
    
    stream.init(file, -1, 0, 0);
    unichar.init(stream, "utf-8", stream.available(), 0);
    return { stream: stream,
             unichar: unichar,
             readFully: function() {
               var str = {};
               this.unichar.readString(this.stream.available(), str);
               return str.value;
             },
             close: function() {
               this.unichar.close();
               this.stream.close();
             }
           };
  },

  pub.getNsiFile = function(file) {
    if (file instanceof Components.interfaces.nsIFile) return file;
    else {
      var nsiFile = Components.classes["@mozilla.org/file/local;1"]
                .createInstance(Components.interfaces.nsIFile);
      nsiFile.initWithPath(file);
      return nsiFile;
    }
  },

  pub.readFile = function(file, unichar) {
    var nsiFile = simplemail.SimpleMailFile.getNsiFile(file);
    var inn = unichar ? simplemail.SimpleMailFile.createUnicharInputStream(nsiFile) 
                      : simplemail.SimpleMailFile.createInputStream(nsiFile);
    try {
      return inn.readFully();
    }
    finally {
      inn.close();
    }
  },

  pub.createLogFile = function() {
    today = new Date();
    var date = simplemail.SimpleMailDate.toShortString(today);
    var date = date.replace(/\//g,"-");
    var file = Components.classes["@mozilla.org/file/directory_service;1"].
           getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
    file.append("Simplemail - " + date + ".log");
    if(!file.exists()) {
      var nsiFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsIFile);
      nsiFile.initWithPath(file.path);
      return nsiFile;
    } else {
      return file;
    }
  },
      
  pub.writeFile = function(file, data, unichar) {
    var nsiFile = simplemail.SimpleMailFile.getNsiFile(file);
    var out = unichar ? simplemail.SimpleMailFile.createUnicharOutputStream(nsiFile)
                      : simplemail.SimpleMailFile.createOutputStream(nsiFile);
    try {
      out.write(data);
    } finally {
      out.close();
    } 
  },

  pub.createTemporaryFile = function() {
    var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
    file.append("simplemail.tmp");
    file.createUnique(file.NORMAL_FILE_TYPE, 0666);

    var out = simplemail.SimpleMailFile.createOutputStream(file);
    var inn = simplemail.SimpleMailFile.createInputStream(file);

    return { write: function(data) { out.write(data); },
             readFully: function() {
               out.buffered.flush();
               return inn.readFully();
             },
             remove: function() {
               out.close();
               inn.close();
               file.remove(false);
             }
           };
  },

  pub.getStatusIconURL = function(status) {
    var image = (status == "loading") ? "loading.gif" : status + ".png";
    return "chrome://simplemail/skin/status/" + image;
  },
     
  pub.getEnvelopeIconURL = function(name) {
    return "chrome://simplemail/skin/envelope/" + name;
  },

  pub.getFileURL = function(file) {
    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    return fileHandler.getURLSpecFromFile(file);
  },

  pub.getMimeType = function(uriOrFile) {
    try {
      var mimeService = Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService);
      if (uriOrFile instanceof Components.interfaces.nsIFile) {
        return mimeService.getTypeFromFile(uriOrFile);
      } else {
        var url = simplemail.SimpleMailFile.getNsiURL(uriOrFile);
        return mimeService.getTypeFromURI(url);
      } 
    } catch(e) {
      return "application/octet-stream";
    }
  },

  pub.getFileExtension = function (url) {
    var filename = simplemail.SimpleMailFile.getFileName(url);
    var ext =  filename.split('.').pop();
    return ext;
  },

  pub.isImage = function(url) {
    var mimeType = simplemail.SimpleMailFile.getMimeType(url);
    return mimeType.match(/^image/i);
  },

  pub.readURL = function(url) {
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
    var channel = ioService.newChannel(url, null, null);

    var input = channel.open();
    bstream.setInputStream(input);

    var size, data = "";
    while((size = bstream.available())) {
      data += bstream.readBytes(size);
    }
    bstream.close();
    input.close();
    return data;
  },

  pub.getFileName = function(url) {
    var nsiUrl = (nsiUrl instanceof Components.interfaces.nsIURL) ? url : simplemail.SimpleMailFile.getNsiURL(url);
    return decodeURIComponent(nsiUrl.fileName);
  },

  pub.getNsiURL = function(url) {
    var nsiUrl = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURL);
    nsiUrl.spec = url;
    return nsiUrl;
  },

  pub.isLocalURL = function(url) {
    return ("" + url).match(/^(file:|chrome:|simplemail:)/i);
  },

  // userok
  pub.chooseFile = function(mode, fileFilters, name) {
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
    fp.init(window, null, mode == "save"     ? fp.modeSave :
                          mode == "folder"   ? fp.modeGetFolder :
                          mode == "multiple" ? fp.modeOpenMultiple : fp.modeOpen);
    for (var i in fileFilters) {
      switch (fileFilters[i]) {
        case "images": 
          fp.appendFilters(fp.filterImages); 
          break;
        case "html":   
          fp.appendFilters(fp.filterHTML); 
          break;
        default:       
          fp.appendFilter(fileFilters[i], fileFilters[i]); 
          break;
      }
    }
    fp.appendFilters(fp.filterAll);
    fp.defaultString = name;

    var result = fp.show();
    if (result == fp.returnOK || result == fp.returnReplace) {
      if (mode != "multiple") return fp.file;
      var enumerate = fp.files;
      var files = [];
      while(enumerate.hasMoreElements()) {
        var file = enumerate.getNext();
        file.QueryInterface(Components.interfaces.nsIFile);
        files.push(file);
      }
      return files;
    }
  },
  
  pub.forEachFile = function(dir, onFile) {
    var files = dir.directoryEntries;
    while(files.hasMoreElements()) {
      var file = files.getNext();
      file.QueryInterface(Components.interfaces.nsIFile);
      onFile(file);
    }
  }

  return pub;
}();

simplemail.SimpleMailSound = function() {
  var pub = {};
  
  pub.sound = Components.classes["@mozilla.org/sound;1"].getService(Components.interfaces.nsISound),
  pub.isPlaying = false,

  pub.getURL = function(path) {
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    return ioService.newURI("file://" + path, null, null);
  },

  pub.getTime = function(path) {
    if (!path) return 0;

    var file = simplemail.SimpleMailFile.getNsiFile(path);
    var inn = simplemail.SimpleMailFile.createInputStream(file);
    var header = inn.binary.readBytes(100);
    inn.close();

    function getInt(regexp) {
      var value = regexp.exec(header)[1];
      return value.charCodeAt(0) +
             value.charCodeAt(1) * 0x100 +
             value.charCodeAt(2) * 0x10000 +
             value.charCodeAt(3) * 0x1000000;
    }

    if (header.match(/^RIFF/)) {
      var bytesPerSec = getInt(/fmt .{12}(.{4})/);
      var bytesTotal = getInt(/data(.{4})/);
      return bytesTotal / bytesPerSec;
    }
  },

  pub.play = function(path) {
    if (simplemail.SimpleMailSound.isPlaying) return;
    simplemail.SimpleMailSound.isPlaying = true;

    try {
      path ? simplemail.SimpleMailSound.sound.play(simplemail.SimpleMailSound.getURL(path))
           : simplemail.SimpleMailSound.sound.playSystemSound("_moz_mailbeep");

      setTimeout(function() { simplemail.SimpleMailSound.isPlaying = false; },
                 simplemail.SimpleMailSound.getTime(path) * 1000);
    } catch(e) {
      simplemail.SimpleMailUtils.error("cantPlaySound", [path]);
    }
  }
  
  return pub;
}();