if (typeof(simplemail) == "undefined" ) {simplemail = {};};

simplemail.SimpleMailManageFolder = function() {
  var pub = {};

  pub.contextFolder = null,
  pub.foldersCounts = null,
  pub.result        = null,
  pub.msgsFolder    = [],
  pub.msgsFolders   = [],
  pub.tmpString     = null,
  pub.chunkSize     = 96 * 1024 * 1024,
  
  pub.displayInbox = function() {
    var browserWindow = simplemail.SimpleMailUtils.getBrowserWindow();
    browserWindow.focus();
  
    var gBrowser = browserWindow.getBrowser();
    gBrowser.selectedTab = simplemail.SimpleMailUtils.getDocumentTab(document);

    if (folderTree.currentIndex != 0)
      folderTree.view.selection.select(0);
    else 
      simplemail.messageTreeView.selectFirstMessage();
    
    messageTree.focus();
  },
  
  pub.getCurrentFolder = function() {
    return simplemail.SimpleMailManageFolder.getFolder(folderTree.currentIndex);
  },
  
  pub.getFolder = function(row) {
    simplemail.SimpleMailManageFolder.index = 0;
    simplemail.SimpleMailManageFolder.forEachOpenFolder(0, function(folder) {
                           if (simplemail.SimpleMailManageFolder.index++ == row) simplemail.SimpleMailManageFolder.result = folder;
                         });
    return simplemail.SimpleMailManageFolder.result;
  },
  
  pub.forEachOpenFolder = function(parentId, onFolder, level) {
    if (!level) level = 0;
    var children = folders[parentId];
    for(var i in children) {
      var child = children[i];
      onFolder(child, level);
      if (child.open) {
        simplemail.SimpleMailManageFolder.forEachOpenFolder(child.id, onFolder, level + 1);
      }
    }
  },
  
  pub.getFolderRow = function(folderId) {
    simplemail.SimpleMailManageFolder.index = 0;
    var row;
    simplemail.SimpleMailManageFolder.forEachOpenFolder(0, function(f) {
                           if (f.id == folderId) row = simplemail.SimpleMailManageFolder.index;
                           simplemail.SimpleMailManageFolder.index++;
                         });
    return row;
  },
  
  pub.getChildCount = function(folderId) {
    var count = 0;
    simplemail.SimpleMailManageFolder.forEachOpenFolder(folderId, function() { count++; });
    return count;
  },
  
  pub.populateFolderMenu = function(event) {
    var row = {}, column = {}, child = {};
    simplemail.folderTreeView.treebox.getCellAt(event.clientX, event.clientY, row, column, child);
    simplemail.SimpleMailManageFolder.contextFolder = (row.value != -1) ? simplemail.SimpleMailManageFolder.getFolder(row.value) : null;
    var isCustomFolder = simplemail.SimpleMailManageFolder.contextFolder && simplemail.SimpleMailManageFolder.contextFolder.id > simplemail.SimpleMailModel.SimpleMailFolder.TRASH;
    simplemail.SimpleMailDom.get("folder-menu-rename").hidden = !isCustomFolder || simplemail.SimpleMailManageFolder.contextFolder.getName() == "SPAM";
    simplemail.SimpleMailDom.get("folder-menu-delete").hidden = !isCustomFolder;
    simplemail.SimpleMailDom.get("folder-menu-import").hidden = !simplemail.SimpleMailManageFolder.contextFolder;
    simplemail.SimpleMailDom.get("folder-menu-archive").hidden = !simplemail.SimpleMailManageFolder.contextFolder;
    simplemail.SimpleMailDom.get("folder-menu-empty").hidden = !simplemail.SimpleMailManageFolder.contextFolder ||
                                            simplemail.SimpleMailManageFolder.contextFolder.id != simplemail.SimpleMailModel.SimpleMailFolder.TRASH;
  },
  
  // userok: async
  pub.setFolderParent = function(callBackDone, folder, parentId) {
    //console.error("SM.setFolderParent_", simplemail.folderTreeView.treebox, simplemail.folderTreeView);//userok_log
    
    if (folder.parentId == parentId) 
      return;

    if (typeof(simplemail.folderTreeView.treebox) == 'undefined'){
      simplemail.folderTreeView = folderTreeView;
    }

    simplemail.folderTreeView.treebox.beginUpdateBatch();
      if (folder.parentId != null) {
        simplemail.folderTreeView.treebox.rowCountChanged(folderTree.currentIndex - 1, -1);
        var siblings = folders[folder.parentId];
        var len = siblings.length;
        loop:
        for (var i=0; i < len; i++) {
          if (typeof(siblings[i]) == 'undefined') {
            // Break loop;
            continue;
          }          
          if (siblings[i].id == folder.id) {
            siblings.splice(i, 1);
          }
        }
      }
    
      folder.parentId = parentId;
      if (!folders[parentId]) {
        folders[parentId] = [];
      }
      folders[parentId].push(folder);

      var parentRow;
      if (parentId == 0) {
        parentRow = simplemail.folderTreeView.rowCount - 1
      } else {
        parentRow = simplemail.SimpleMailManageFolder.getFolderRow(parentId);
      }
                                     
      if (parentRow) {
        simplemail.folderTreeView.treebox.rowCountChanged(parentRow + 1, 1);
      }
    simplemail.folderTreeView.treebox.endUpdateBatch();

    simplemail.SimpleMailOverlay.storage.saveFolder(function(fldr) { // userok: async
      simplemail.SimpleMailManageFolder.updateFolderCounts();
      //!userok break this !simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
      //!userok: this break setFolderParent from archive.js (dont't know realyneed this? have no see bad side effects)
      if (callBackDone)
        callBackDone(folder, parentId);
    }, folder);
  },
  
  pub.checkFolder = function(name, parentId) {
    var tfolders = simplemail.SimpleMailOverlay.storage.getFolders();
    for (var i in tfolders) {
      var children = tfolders[i];
      for (var j in children) {
        if (children[j].name.toLowerCase() == name.toLowerCase() && children[j].parentId == parentId) {
          simplemail.SimpleMailUtils.alert(simplemail.SimpleMailBundle.getString("alreadyExist"));
          return false;
        }
      }
    }
    
    for (var k in simplemail.SimpleMailModel.SimpleMailFolder.DEFAULT_NAMES) {
      var foldersDefault = simplemail.SimpleMailModel.SimpleMailFolder.DEFAULT_NAMES[k];
      var folderDefault  = simplemail.SimpleMailBundle.getString(foldersDefault);
      if (name.toLowerCase() == foldersDefault.toLowerCase() || name.toLowerCase() == folderDefault.toLowerCase()){
        simplemail.SimpleMailUtils.alert(simplemail.SimpleMailBundle.getString("alreadyExist"));
        return false;
      }
    }
    
    return true;
  },
  
  // userok: async
  pub.addFolder = function() {
    var name = {};
    if (simplemail.SimpleMailUtils.prompt("folderName", name) && name.value) {
      var parentId = simplemail.SimpleMailManageFolder.contextFolder ? simplemail.SimpleMailManageFolder.contextFolder.id : 0;
      if (simplemail.SimpleMailManageFolder.checkFolder(name.value, parentId)) {
        var folder = new simplemail.SimpleMailModel.SimpleMailFolder(null, null, name.value);
        simplemail.SimpleMailManageFolder.setFolderParent(0, folder, parentId); // userok: async
      }
    }
  },
  
  // userok: async
  pub.renameFolder = function() {
    var name = { value: simplemail.SimpleMailManageFolder.contextFolder.getName() };
    var parentId = simplemail.SimpleMailManageFolder.contextFolder ? simplemail.SimpleMailManageFolder.contextFolder.id : 0;
    if (simplemail.SimpleMailUtils.prompt("folderName", name) && name.value) {
      if (simplemail.SimpleMailManageFolder.checkFolder(name.value, parentId)) {
        simplemail.SimpleMailManageFolder.contextFolder.name = name.value;
        simplemail.folderTreeView.treebox.invalidateRow(folderTree.currentIndex);
        simplemail.SimpleMailOverlay.storage.saveFolder(0, simplemail.SimpleMailManageFolder.contextFolder); // userok
      }
    }
  },
  
  // userok: async
  pub.deleteFolder = function() {
    var folder = simplemail.SimpleMailManageFolder.contextFolder;
    var name   = simplemail.SimpleMailManageFolder.contextFolder.getName();
    if (folder.parentId != simplemail.SimpleMailModel.SimpleMailFolder.TRASH && simplemail.SimpleMailPrefs.getBool("moveToTrash")) {
      if (name == "SPAM")
        simplemail.SimpleMailManageFolder.deleteFilterSPAM(name);

      simplemail.SimpleMailPrefs.setBool('movespam', false);
      simplemail.SimpleMailPrefs.setBool('trashspam', false);
      simplemail.SimpleMailPrefs.setBool('deletespam', false);
      simplemail.SimpleMailPrefs.setBool('nospam', true);
      simplemail.SimpleMailPrefs.setBool('markspamasread', false);
      // Add
      var parentRow = simplemail.SimpleMailManageFolder.getFolderRow(folder.parentId);
      var parentFolder = simplemail.SimpleMailManageFolder.getFolder(parentRow);
      var children = simplemail.SimpleMailManageFolder.getChildCount(folder.parentId);
      if (parentFolder.open && children == 1)
        simplemail.folderTreeView.toggleOpenState(parentRow);
      
      return simplemail.SimpleMailManageFolder.setFolderParent(0, folder, simplemail.SimpleMailModel.SimpleMailFolder.TRASH); // userok: async 
    }
    
    var confirmText = simplemail.SimpleMailBundle.getString("deleteFolder", [name]);
    simplemail.SimpleMailManageFolder.askDeleteFolder(folder, confirmText);
    if (name == "SPAM")
      simplemail.SimpleMailManageFolder.deleteFilterSPAM(name);
  },

  // userok: async
  pub.deleteFilterSPAM = function(name) {
    var tfilters = simplemail.SimpleMailOverlay.storage.getFilters();
    for (var i in tfilters) {
      if (tfilters[i].name == name) {
        if (simplemail.SimpleMailUtils.confirm(simplemail.SimpleMailBundle.getString("deleteFilter")))
          simplemail.SimpleMailOverlay.storage.deleteFilter(0, tfilters[i]); // userok: async
      }
    }
  },
  
  pub.emptyTrash = function() {
    if (!simplemail.SimpleMailManageFolder.isTrashEmpty()) {
      var confirmText = simplemail.SimpleMailBundle.getString("emptyTrash");
      simplemail.SimpleMailManageFolder.askDeleteFolder(simplemail.SimpleMailManageFolder.contextFolder, confirmText, true);
    }
  },
  
  pub.forEachFolder = function(folder, onFolder) {
    var children = folders[folder.id];
    for(var i in children) {
      simplemail.SimpleMailManageFolder.forEachFolder(children[i], onFolder);
    }
    onFolder(folder);
  },
  
  pub.getFolderMessages = function (folder) {
    simplemail.SimpleMailManageFolder.msgsFolders = [];
    simplemail.SimpleMailManageFolder.forEachFolder(folder, function(f) {
      simplemail.SimpleMailManageFolder.msgsFolders = simplemail.SimpleMailManageFolder.msgsFolders.concat(simplemail.SimpleMailOverlay.storage.getFolderMessages(f.id));
    });
    return simplemail.SimpleMailManageFolder.msgsFolders;
  },  

  // userok: async
  pub.askDeleteFolder = function(folder, confirmText, childrenOnly, onExit) {

    function doDeleteFolder() {
      simplemail.SimpleMailOverlay.storage.deleteFolder(function(fldr, childOnly) { // userok: async
        if (!onExit) {
          // Update tree: delete child folders
          var folderRow = simplemail.SimpleMailManageFolder.getFolderRow(folder.id);
          var children  = folderRow && folder.open ? simplemail.SimpleMailManageFolder.getChildCount(folder.id) : 0;

          simplemail.SimpleMailManageFolder.forEachFolder(folder, function(f) {
            delete folders[f.id];
          });

          simplemail.folderTreeView.treebox.rowCountChanged(folderRow, -children);

          if (childrenOnly) {
            if (folderRow == folderTree.currentIndex) simplemail.SimpleMailManageFolder.displayInbox();
            return;
          }

          // Update tree: delete folder itself
          var siblings = folders[folder.parentId];
          var len = siblings.length;
          for (var i=0; i < len; i++) {
            if (siblings[i].id == folder.id) {
              siblings.splice(i, 1);
              simplemail.folderTreeView.treebox.rowCountChanged(folderRow - 1, -1);
            }
          }
          // Add
          var parentRow = simplemail.SimpleMailManageFolder.getFolderRow(folder.parentId);
          var parentFolder = simplemail.SimpleMailManageFolder.getFolder(parentRow);
          var parentChildren = simplemail.SimpleMailManageFolder.getChildCount(folder.parentId);
          if (parentFolder.open && parentChildren == 1)
            simplemail.folderTreeView.toggleOpenState(parentRow);
             
          if (folder.name == "SPAM") {
            simplemail.SimpleMailPrefs.setBool('movespam', false);
            simplemail.SimpleMailPrefs.setBool('trashspam', false);
            simplemail.SimpleMailPrefs.setBool('deletespam', false);
            simplemail.SimpleMailPrefs.setBool('nospam', true);
            simplemail.SimpleMailPrefs.setBool('markspamasread', false);
          }
        }
      }, folder, childrenOnly);
    }
    // All messages including subfolders
    simplemail.SimpleMailManageFolder.msgsFolder = simplemail.SimpleMailManageFolder.getFolderMessages(folder);

    if (simplemail.SimpleMailManageFolder.msgsFolder.length) {
      simplemail.SimpleMailOverlay.askDeleteMail(simplemail.SimpleMailManageFolder.msgsFolder, confirmText, window, function() {
        //!userok break this if (simplemail.SimpleMailManageFolder.getFolderMessages(folder).length == 0) 
        //!userok: async storage.deleteMessage can not catch to this moment
          doDeleteFolder();
      });
    } else if (simplemail.SimpleMailUtils.confirm(confirmText)) 
      doDeleteFolder();
  },

  pub.importFolder = function() { // userok: this proc is hard to understand..
    var folder = simplemail.SimpleMailManageFolder.getCurrentFolder();
    var files  = simplemail.SimpleMailFile.chooseFile("multiple");
    if (!files) 
      return;

    for (var i in files) {
      simplemail.SimpleMailManageFolder.tmpString = null;
      var file               = files[i];
      var thefile            = File(file);
      var fileSize           = (thefile.size - 1)
      var currentFilePointer = 0;         
      if (fileSize <= simplemail.SimpleMailManageFolder.chunkSize)
        simplemail.SimpleMailManageFolder.chunkSize = fileSize;

      var totalBytesRemaining = fileSize;
      var reader              = new FileReader();

      reader.onloadend = function(evt) {
        if (evt.target.readyState == FileReader.DONE) {
          var tmpResult      = new Array();
          var tmpArray       = new Array();
          var tmpResult1     = new Array();
          var tmpfinalResult = new Array(); 
          var chunks;
          chunks = evt.target.result.split(/(?=^From .*\r\n)|\r?\n(?=From .*\r\n)/);
          var len = chunks.length;
          for(var j = 0; j < len; j++) {
            if(typeof(chunks[j+1]) !== 'undefined' && (chunks[j].match(/^From .*\r\n/) && chunks[j+1].match(/^From .*\r\n/))){
                tmpResult.push(chunks[j]); // Chunks is a complete message without attachment
            } else if ((chunks[j].match(/^From .*\r\n/) && chunks[j].match(/--\r\n$/))) {
              tmpResult.push(chunks[j]); // Chunks is a complete message with attachment
            } else { // Chunks is a part of a message
              if (simplemail.SimpleMailManageFolder.tmpString == null) {  // First pass
                simplemail.SimpleMailManageFolder.tmpString = chunks[j].toString();
              } else { // Other pass
                simplemail.SimpleMailManageFolder.tmpString += chunks[j].toString();
              }
            }  
          }

          if (simplemail.SimpleMailManageFolder.tmpString !== null) {
            tmpArray = simplemail.SimpleMailManageFolder.tmpString.split(/(?=^From .*\r\n)|\r?\n(?=From .*\r\n)/);
            simplemail.SimpleMailManageFolder.tmpString = "";
            var len2 = tmpArray.length;
            for (var x = 0; x < len2; x++) {
              if (typeof(tmpArray[x+1]) !== 'undefined' && (tmpArray[x].match(/^From .*\r\n/) && tmpArray[x+1].match(/^From .*\r\n/))) {
                tmpResult1.push(tmpArray[x]); // tmpArray is a complete message without attachment
              } else if ((tmpArray[x].match(/^From .*\r\n/) && tmpArray[x].match(/--\r\n$/))) {
                tmpResult1.push(tmpArray[x]);  // tmpArray is a complete message with attachment
              } else  { // tmpArray is a part of a message
                if (simplemail.SimpleMailManageFolder.tmpString == "") {  // First pass
                  simplemail.SimpleMailManageFolder.tmpString = tmpArray[x].toString();
                } else { // Other pass
                  simplemail.SimpleMailManageFolder.tmpString += tmpArray[x].toString();
                }
              }
            }
          }

          if (tmpResult != "")
            tmpfinalResult = tmpResult.concat(tmpResult1)

          if (file.leafName.match(/\.eml$/))
            tmpfinalResult = [ evt.target.result ];

          var len  = tmpfinalResult.length;
          var msgs = [];
          for (var j = 0; j < len; j++) {
            var chunk   = tmpfinalResult[j].replace(/\r\n$/, "");
            var message = simplemail.SimpleMailModel.SimpleMailMessage.parse(chunk, true);
            message.folderId = folder.id;
            simplemail.SimpleMailOverlay.storage.saveMessage(message);
          } 
          readFileInBlocks();
        }
      }
      readFileInBlocks();
    }

    function readFileInBlocks() {
      if (totalBytesRemaining > 0) {
        var title = simplemail.SimpleMailBundle.getString("import");
        var text = simplemail.SimpleMailBundle.getString("importText");
        try {
          Components.classes['@mozilla.org/alerts-service;1'].
                    getService(Components.interfaces.nsIAlertsService).
                    showAlertNotification("chrome://simplemail/skin/status/mail_std_large.png", title, text, false, '', null);      
        } catch (e) {
          // This can fail on Mac OS X
          var win = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].getService(Components.interfaces.nsIWindowWatcher).openWindow(null, 'chrome://global/content/alerts/alert.xul', '_blank', 'chrome,titlebar=no,popup=yes', null);
          win.arguments = ["chrome://simplemail/skin/status/mail_std_large.png", title, text, false, ''];          
        }
        var fileChunk = thefile.slice(currentFilePointer, currentFilePointer + simplemail.SimpleMailManageFolder.chunkSize);
        reader.readAsBinaryString(fileChunk);
        currentFilePointer  += simplemail.SimpleMailManageFolder.chunkSize;
        totalBytesRemaining -= simplemail.SimpleMailManageFolder.chunkSize;
        if (totalBytesRemaining <= simplemail.SimpleMailManageFolder.chunkSize)
          simplemail.SimpleMailManageFolder.chunkSize = totalBytesRemaining;
      } else { // End of read then parse and save messages
        var finalResult;
        var tmpArray2 = new Array();
        try {
          var title = simplemail.SimpleMailBundle.getString("import");
          var text = simplemail.SimpleMailBundle.getString("importSaving");
          Components.classes['@mozilla.org/alerts-service;1'].
                    getService(Components.interfaces.nsIAlertsService).
                    showAlertNotification("chrome://simplemail/skin/status/mail_std_large.png", title, text, false, '', null);      
        } catch (e) {
          // This can fail on Mac OS X
          var win = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].getService(Components.interfaces.nsIWindowWatcher).openWindow(null, 'chrome://global/content/alerts/alert.xul', '_blank', 'chrome,titlebar=no,popup=yes', null);
          win.arguments = ["chrome://simplemail/skin/status/mail_std_large.png", title, text, false, ''];          
        }       

        if (!file.leafName.match(/\.eml$/)) {
          if (simplemail.SimpleMailManageFolder.tmpString !== null) {
            tmpArray2 = simplemail.SimpleMailManageFolder.tmpString.split(/(?=^From .*\r\n)|\r?\n(?=From .*\r\n)/);
            finalResult = tmpArray2;
          }

          var len  = finalResult.length;
          var msgs = [];
          for (var j = 0; j < len; j++) {
            var chunk = finalResult[j].replace(/\r\n$/, "");
            var message = simplemail.SimpleMailModel.SimpleMailMessage.parse(chunk, true);
            message.folderId = folder.id;
            simplemail.SimpleMailOverlay.storage.saveMessage(message);
          }
        }
        // Refresh UI
        setTimeout (function () {
          try {
            var title = simplemail.SimpleMailBundle.getString("import");
            var text = simplemail.SimpleMailBundle.getString("importOk");
            Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService).showAlertNotification("chrome://simplemail/skin/status/mail_std_large.png", title, text, false, '', null);      
          } catch (e) {
            // This can fail on Mac OS X
            var win = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].
                      getService(Components.interfaces.nsIWindowWatcher).
                      openWindow(null, 'chrome://global/content/alerts/alert.xul',
                                '_blank', 'chrome,titlebar=no,popup=yes', null);
            win.arguments = ["chrome://simplemail/skin/status/mail_std_large.png", title, text, false, ''];          
          }          
          simplemail.SimpleMailManageFolder.updateFolderCounts();
          simplemail.SimpleMailOverlay.updateIcons();
          simplemail.SimpleMailOverlay.refreshTab("chrome://simplemail/content/main/main.xul");
        }, 500);
      }
    }
  },

  pub.getFolderCount = function(folderId, name) {
    if (!simplemail.SimpleMailManageFolder.folderCounts) 
      simplemail.SimpleMailManageFolder.folderCounts = simplemail.SimpleMailOverlay.storage.updateFolderCounts();
    var counts = simplemail.SimpleMailManageFolder.folderCounts && simplemail.SimpleMailManageFolder.folderCounts[folderId];
    return counts && counts[name] || 0;
  },
  
  pub.updateFolderCounts = function() {
    //console.error("SM.updateFolderCounts1", simplemail.folderTreeView.treebox, simplemail.folderTreeView);//userok_log
    
    simplemail.SimpleMailManageFolder.folderCounts = null;
    simplemail.folderTreeView.treebox.invalidate();
    simplemail.SimpleMailOverlay.updateIcons();
    
    //console.error("SM.updateFolderCounts2", simplemail.folderTreeView, simplemail.folderTreeView.treebox);//userok_log
  },
  
  pub.isTrashEmpty = function() {
    var children = folders[simplemail.SimpleMailModel.SimpleMailFolder.TRASH];
    return (!children || !children.length) && !simplemail.SimpleMailManageFolder.getFolderCount(simplemail.SimpleMailModel.SimpleMailFolder.TRASH, "total");
  },
  
  // Get folder's id by name
  pub.getFolderId = function(folderName) {
    var tfolders = simplemail.SimpleMailOverlay.storage.getFolders();
    for (var i in tfolders) {
      var children = tfolders[i];
      for (var j in children) {
        if (children[j].name == folderName) {
          var folderNameId = children[j].id
          return folderNameId
        }
      }
    }
  }
  
  return pub;
}();

simplemail.folderTreeView = function() {
  var pub = {
    get rowCount() {
      return simplemail.SimpleMailManageFolder.getChildCount(0);
    }
  };

  pub.result = null,
  pub.row = null,  
  
  pub.getCellText = function(row, column) {
    var folder = simplemail.SimpleMailManageFolder.getFolder(row);
    var name = column.id.replace(/folder-/, "");
    var count = simplemail.SimpleMailManageFolder.getFolderCount(folder.id, name);
    switch(name) {
      case "name":   return folder.getName();
      case "size":   return simplemail.SimpleMailUtils.size2string(count);
      default:       return count;
    }
  },
  
  pub.getCellProperties = function(row, column, props) {
    var folder = simplemail.SimpleMailManageFolder.getFolder(row);
    var folderProps = new Array();
    var name = column.id.replace(/folder-/, "");
    switch(name) {
      case "name":
        var type = (folder.id == simplemail.SimpleMailModel.SimpleMailFolder.TRASH) ? "trash" : "folder";
        if (props) {
          var atom = simplemail.folderTreeView.atomService.getAtom(type);
          props.AppendElement(atom);
        } else folderProps.push(type);
        if (folder.id == simplemail.SimpleMailModel.SimpleMailFolder.TRASH && simplemail.SimpleMailManageFolder.isTrashEmpty()) {
          if (props) {
            var atom = simplemail.folderTreeView.atomService.getAtom("empty");
            props.AppendElement(atom);
          } else folderProps.push("empty");
        }
        simplemail.SimpleMailManageFolder.getFolderId("SPAM");
          if (folder.name == "SPAM"){
            if (props) {
              var atom = simplemail.folderTreeView.atomService.getAtom("spamfolder");
              props.AppendElement(atom);
            } else folderProps.push("spamfolder");
          }
        if (simplemail.SimpleMailManageFolder.getFolderCount(folder.id, "unread") ||
            (simplemail.SimpleMailManageFolder.getFolderCount(folder.id, "childUnread") && !folder.open))
        {
          if (props) {
            var atom = simplemail.folderTreeView.atomService.getAtom("unread");
            props.AppendElement(atom);
          } else folderProps.push("unread");
        }
        break;
      case "unread":
        if (simplemail.SimpleMailManageFolder.getFolderCount(folder.id, "unread")) {
          if (props) {
            var atom = simplemail.folderTreeView.atomService.getAtom("unread");
            props.AppendElement(atom);
          } else folderProps.push("unread");
        }
        break;
    }
    return folderProps.join(" ");
  },
  
  pub.isContainer = function(row) {
    return true;
  },
  
  pub.isContainerOpen = function(row) {
    return simplemail.SimpleMailManageFolder.getFolder(row).open;
  },
  
  pub.isContainerEmpty = function(row) {
    var folder = simplemail.SimpleMailManageFolder.getFolder(row);
    return !folders[folder.id] || folders[folder.id].length == 0;
  },
  
  pub.getParentIndex = function(row) {
    var folder = simplemail.SimpleMailManageFolder.getFolder(row);
    return simplemail.SimpleMailManageFolder.getFolderRow(folder.parentId) || -1;
  },
  
  pub.getLevel = function(row) {
    simplemail.SimpleMailManageFolder.index = 0;
    simplemail.SimpleMailManageFolder.forEachOpenFolder(0, function(folder, level) {
                           if (simplemail.SimpleMailManageFolder.index++ == row) simplemail.folderTreeView.result = level;
                         });
    return simplemail.folderTreeView.result;
  },
  
  pub.hasNextSibling = function(row, afterRow) {
    var folder = simplemail.SimpleMailManageFolder.getFolder(row);
    simplemail.SimpleMailManageFolder.index = 0;
    simplemail.SimpleMailManageFolder.forEachOpenFolder(folder.parentId,
                      function(f, level) {
                        if (f.id == folder.id) simplemail.SimpleMailManageFolder.index = 0;
                        if (level == 0 &&
                            simplemail.SimpleMailManageFolder.index > afterRow - row) simplemail.folderTreeView.result = true;
                            simplemail.SimpleMailManageFolder.index++;
                      });
    return simplemail.folderTreeView.result;
  },
  
  // userok: async
  pub.toggleOpenState = function(row) {
    var folder = simplemail.SimpleMailManageFolder.getFolder(row);
    if (!folder.open && simplemail.folderTreeView.isContainerEmpty(row)) return;

    folder.open = !folder.open;
    simplemail.folderTreeView.treebox.rowCountChanged(row + 1,
      (folder.open ? 1 : -1) * simplemail.SimpleMailManageFolder.getChildCount(folder.id));

    simplemail.SimpleMailOverlay.storage.saveFolder(0, folder); // userok
  },
  
  pub.canDrop = function(row, orientation) {
    if (orientation == simplemail.folderTreeView.DROP_ON) {
      if (simplemail.dragObserver.source == messageTree) return true;

      if (simplemail.dragObserver.source == folderTree) {
        // Deny setting self or child as a parent
        var folder = simplemail.SimpleMailManageFolder.getCurrentFolder();
        var newParent = simplemail.SimpleMailManageFolder.getFolder(row);

        simplemail.folderTreeView.result = folder.id != newParent.id;
        simplemail.SimpleMailManageFolder.forEachOpenFolder(folder.id, function(f) {
                                       if (f.id == newParent.id) simplemail.folderTreeView.result = false;
                                     });
        return simplemail.folderTreeView.result;
      }
    }
    if (orientation == simplemail.folderTreeView.DROP_AFTER &&
        simplemail.dragObserver.source == folderTree &&
        row == simplemail.folderTreeView.rowCount - 1) return true;
  },
  
  pub.drop = function(row, orientation) {
    var target = simplemail.SimpleMailManageFolder.getFolder(row);

    if (simplemail.dragObserver.source == folderTree) {
      var folder = simplemail.SimpleMailManageFolder.getCurrentFolder();
      var parentId = (orientation != simplemail.folderTreeView.DROP_AFTER) ? target.id : 0;
      simplemail.SimpleMailManageFolder.setFolderParent(0, folder, parentId); // userok: async
    } else if (simplemail.dragObserver.source == messageTree) {
      simplemail.messageTreeView.moveToFolder(target.id);
    }
    simplemail.dragObserver.source = null;
  }
  return pub;
}();

simplemail.DefaultTreeView.extend(simplemail.folderTreeView);

// Drag-n-Drop
simplemail.dragObserver = function(){
  var pub = {};
 
  pub.source = null,
  
  pub.onDragStart = function(event, transferData, action) {
    if (event.target.nodeName != "treechildren") return;

    if (event.target.parentNode == folderTree) {
      var folder = simplemail.SimpleMailManageFolder.getCurrentFolder();
      if (folder.id <= simplemail.SimpleMailModel.SimpleMailFolder.TRASH) return false;
    }
    transferData.data = new TransferData();
    transferData.data.addDataForFlavour("text/unicode", "");
    simplemail.dragObserver.source = event.target.parentNode;
  },
  
  pub.getSupportedFlavours = function() {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/unicode");
    return flavours;
  },
  
  pub.onDrop = function(event, transferData, session) {}

  return pub;
}();