if (typeof(simplemail) == "undefined" ) {simplemail = {};};

simplemail.SimpleMailOverlay = function() {
  var pub = {addonVersion: "2.87", URL: "chrome://simplemail/content/main/main.xul", storage: null}; //userok

  // userok: async
  pub.preinitialize = function() {
    //console.error("SM.SimpleMailOverlay_preinitialize", this);//userok_log
    // init storage
    simplemail.SimpleMailOverlay.storage = new simplemail.SimpleMailStorageManager.SimpleMailStorage();
    simplemail.SimpleMailOverlay.storage.initStorage(function() {
      // init accounts, folders, filters, addressbook
      simplemail.SimpleMailOverlay.storage.doGetAccounts(function(taccounts) {
        simplemail.SimpleMailOverlay.storage.dogetFolders(function(tfolders) {
          simplemail.SimpleMailOverlay.storage.doGetFilters(function(tfilters) {
            simplemail.SimpleMailOverlay.storage.dogetAddresses(function(tAddressBook) {
              simplemail.SimpleMailOverlay.initialize();
            });
          });
        });
      });       
    });
  },
  
  pub.initialize = function() {
    //console.error("SM.SimpleMailOverlay_initialize", simplemail, window);//userok_log
    var smurl        = "http://www.userlogos.org/extensions/simplemail/changelog";
    var addonVersion = simplemail.SimpleMailOverlay.addonVersion;
    var firstRun     = simplemail.SimpleMailOverlay.storage.firstRun;
    
    // add SM button for first run
    if (firstRun)
      simplemail.SimpleMailOverlay.installSimpleMailIcon("nav-bar", "SimpleMailButton");

    // create welcome letter for first run and open userlogos when first run or update
    setTimeout(function() {
      if (firstRun) { // First Run
				simplemail.SimpleMailOverlay.createWelcomeLetter();
        simplemail.SimpleMailOverlay.handleMailto();
        var gBrowser = simplemail.SimpleMailUtils.getBrowser();
        gBrowser.selectedTab = gBrowser.addTab(smurl);
        simplemail.SimpleMailPrefs.setString("version", addonVersion);
      } else {        // Update
        if (addonVersion !== simplemail.SimpleMailPrefs.getString("version")) {
          var gBrowser = simplemail.SimpleMailUtils.getBrowser();
          gBrowser.selectedTab = gBrowser.addTab(smurl);
          simplemail.SimpleMailPrefs.setString("version", addonVersion);
        }
      }
      
      // check mail on start and create autocheck timers
      if (simplemail.SimpleMailPrefs.getBool("checkOnStartup")) 
        simplemail.SimpleMailOverlay.getMail();
      else {
        simplemail.SimpleMailOverlay.lastCheckTime = new Date();
        var taccounts = simplemail.SimpleMailOverlay.storage.getAccounts();
        for (var i in taccounts) {
          var account = taccounts[i];
          if (account.refresh > 0) {          
            var listener = new simplemail.SimpleMailOverlay.GetMailListener(account);
            //userok
            simplemail.SimpleMailOverlay.timeouts[account.id] = 
              setTimeout(function(accId) {
                //console.error("SM.SimpleMailOverlay.initialize.accId", accId); //userok_log
                simplemail.SimpleMailOverlay.getMail(accId);
              }, account.refresh * 60 * 1000, account.id);
          }
        }
        simplemail.SimpleMailOverlay.updateIcons();
      }
    }, 50);

    simplemail.SimpleMailDom.get("contentAreaContextMenu").addEventListener("popupshowing", simplemail.SimpleMailOverlay.onContentMenuShowing, false);
  },

  pub.getMainWindow = function(initialized) {
   var gBrowser = simplemail.SimpleMailUtils.getBrowser();
    for (var i = 0; i < gBrowser.browsers.length; i++) {
      var browser = gBrowser.browsers[i];
      if (browser.currentURI.spec == simplemail.SimpleMailOverlay.URL) {
        var wnd = browser.contentWindow.wrappedJSObject;
        if (!initialized || wnd.initialized)
          return wnd;
      }
    }
  },
  
  pub.handleMailto = function() {
    // Make "mailto:" URLs handled by SM
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefs.setBoolPref("network.protocol-handler.expose.mailto", true);
    prefs.setBoolPref("network.protocol-handler.external.mailto", false);
  },

  pub.createWelcomeLetter = function() {
    var text         = "Content-Type: text/plain; charset=utf-8\r\n" + simplemail.SimpleMailBundle.getString("welcomeMessage");
    var message      = simplemail.SimpleMailModel.SimpleMailMessage.parse(simplemail.SimpleMailText.fromUnicode(text, "utf-8"));
    message.date     = new Date();
    message.folderId = simplemail.SimpleMailModel.SimpleMailFolder.INBOX;
    simplemail.SimpleMailOverlay.addMessage(message);
  },
  
  pub.installSimpleMailIcon = function (toolbarId, buttonId) {
    if (!document.getElementById(buttonId)) {
      var toolbar = document.getElementById(toolbarId);
 
      toolbar.insertItem(buttonId, null, null, false);
      toolbar.setAttribute("currentset", toolbar.currentSet);
      document.persist(toolbar.id, "currentset");
    }
  },
  
  pub.isRunning = function() {
    return simplemail.SimpleMailOverlay.instances.length;
  },

  pub.onClick = function(event) {
    if (event.button == 1) 
      simplemail.SimpleMailOverlay.getMail();
    else if (!event.button) {
      if (event.type == "dblclick") 
        simplemail.SimpleMailOverlay.stop();
      else 
        simplemail.SimpleMailOverlay.open(event);
    }
  },

  pub.stop = function() {
    for (var i = 0; i < simplemail.SimpleMailOverlay.instances.length; i++)
      simplemail.SimpleMailOverlay.instances[i].stop();
  },

  pub.open = function(event) {
    var mainWindow = simplemail.SimpleMailOverlay.getMainWindow();
    if (mainWindow) {
      if (mainWindow.initialized)
        mainWindow.simplemail.SimpleMailManageFolder.displayInbox();
    } else {
      var where = simplemail.SimpleMailUtils.whereToOpenLink(event);
      if (!where && !simplemail.SimpleMailPrefs.getBool("openInCurrentTab")) where = "tab";
      if (where == "window")
        where = "tabshifted";
      simplemail.SimpleMailUtils.openUILink(simplemail.SimpleMailOverlay.URL, where);
    }
  },
  
  pub.prefsWindow = null,

  pub.openPreferences = function() {
      simplemail.SimpleMailOverlay.prefsWindow = openDialog("chrome://simplemail/content/preferences/preferences.xul",
                                          "simplemail-preferences-window","chrome,centerscreen,modal,resizable");
  },

  pub.tmp        = [],
  pub.mailWindow = null,
  pub.mailTab    = null,

  pub.openNewMessage = function(message, mailto) {
    //console.error("SM.openNewMessage", message, mailto);//userok_log
    
    var taccounts = simplemail.SimpleMailOverlay.storage.getAccounts();
    if (!taccounts.length) 
      return;

    var LMessage = message; // userok fix warning
    if (mailto) 
      LMessage = simplemail.SimpleMailModel.SimpleMailMessage.parseMailto(mailto);
    if (!LMessage) 
      LMessage = new simplemail.SimpleMailModel.SimpleMailMessage();

    var tmpId = simplemail.SimpleMailUtils.getUniqueId();
    simplemail.SimpleMailOverlay.tmp[tmpId] = LMessage;

    var url = "chrome://simplemail/content/newmessage.xul";
    
    if (simplemail.SimpleMailPrefs.getBool("messagesInWindow")) {
      simplemail.SimpleMailPrefs.setString('tmpId', tmpId);
      simplemail.SimpleMailPrefs.setObject('message', LMessage);
      // userok: what for?  var gBrowser = simplemail.SimpleMailUtils.getBrowser();
    }

    if (simplemail.SimpleMailPrefs.getBool("newMessagesInWindow")) {
      simplemail.SimpleMailOverlay.mailWindow = window.open(url, tmpId, "dependent,chrome=no,location=no,status=no,height=400,width=700,resizable");
      simplemail.SimpleMailPrefs.setString('tmpId', tmpId);
      simplemail.SimpleMailPrefs.setObject('message', LMessage);
    } else {
      var gBrowser = simplemail.SimpleMailUtils.getBrowser();
      content.location != "about:blank" ? gBrowser.selectedTab = gBrowser.addTab(url + "?" + tmpId) : content.location.assign(url + "?" + tmpId);
    }
  },

  pub.openedWindows = [],

  pub.refreshTab = function(url) { 
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);  
    var browserEnumerator = wm.getEnumerator("navigator:browser");  

    var found = false;  
    while (!found && browserEnumerator.hasMoreElements()) {  
      var browserWin = browserEnumerator.getNext();  
      var tabbrowser = browserWin.gBrowser;  

      var numTabs = tabbrowser.browsers.length;  
      for (var index = 0; index < numTabs; index++) {  
        var currentBrowser = tabbrowser.getBrowserAtIndex(index);  
        if (url == currentBrowser.currentURI.spec) {  
          tabbrowser.selectedTab = tabbrowser.tabContainer.childNodes[index];  
          browserWin.focus();

          if (simplemail.SimpleMailOverlay.openedWindows.length > 0) {
            var openedWin = simplemail.SimpleMailOverlay.openedWindows;
            tabbrowser.reload();
            simplemail.SimpleMailOverlay.openedWindows = openedWin;
          } else
            tabbrowser.reload();

          found = true;  
          break;  
        }  
      }  
    }

    if (!found) {  
      var recentWindow = wm.getMostRecentWindow("navigator:browser");  
      if (recentWindow)
        recentWindow.delayedOpenTab(url, null, null, null, null)
      else
        window.open(url); 
    }
  },

  pub.testTabUrl = function(url) { 
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var recentWindow = wm.getMostRecentWindow("navigator:browser");
    var actualWindow = recentWindow.getBrowser();

    if (actualWindow.currentURI.spec == url) 
      return true;
  },

  pub.populateMenu = function(menupopup) {
    //console.error("SM.Overlay_populateMenu", this, menupopup);//userok_log
    var taccounts = simplemail.SimpleMailOverlay.storage.getAccounts();
    if (!taccounts.length) 
      return false;

    simplemail.SimpleMailUtils.clearElement(menupopup);

    for (var i in taccounts) {
      var account = taccounts[i];
      if (!account.pop3.host) 
        continue;

      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("id", account.id);
      menuitem.setAttribute("label", account);
      menuitem.setAttribute("class", "menuitem-iconic");
      menuitem.setAttribute("image", simplemail.SimpleMailFile.getEnvelopeIconURL(account.color));
      menuitem.addEventListener("click", simplemail.SimpleMailOverlay.onMenuClick); // userok
      menuitem.setAttribute("disabled", !simplemail.SimpleMailOverlay.timeouts[account.id]);
      menupopup.appendChild(menuitem);
    }
  },

  pub.onMenuClick = function(event) {
    //console.error("SM.Overlay_onMenuClick", event, this);//userok
    var accountId = event.target.id;
    switch (event.button) {
      case 0:
        simplemail.SimpleMailOverlay.getMail(accountId);
        for (var element = event.target; element; element = element.parentNode) {
          if (element.nodeName == "menupopup") 
            element.hidePopup();
        }
        break;
      case 2:
        clearTimeout(simplemail.SimpleMailOverlay.timeouts[accountId]);
        delete simplemail.SimpleMailOverlay.timeouts[accountId];
        break;
    }
    event.target.setAttribute("disabled", !simplemail.SimpleMailOverlay.timeouts[accountId]);
  },

  pub.onContentMenuShowing = function(event) {
    var taccounts = simplemail.SimpleMailOverlay.storage.getAccounts();
    
    if (event.target.id == "contentAreaContextMenu")
      simplemail.SimpleMailDom.get("SimpleMail-content-send-menu").hidden = !taccounts.length
    else if (event.target.id == "SimpleMail-content-send-menu")
      simplemail.SimpleMailOverlay.populateFavoriteMenu(event.target);
  },

  // userok: rewrite
  pub.populateFavoriteMenu = function(menupopup) {
    simplemail.SimpleMailUtils.clearElement(menupopup);
    
    var haveFav;    
    var taddresses = simplemail.SimpleMailOverlay.storage.getAddresses();
    for (var i in taddresses) {
      if (taddresses[i].favorite) {
        var menuitem = document.createElement("menuitem");
        menuitem.setAttribute("label", taddresses[i].name || taddresses[i]);
        var fav = taddresses[i].toString();
        menuitem.addEventListener("command",
                                    function(fav) {
                                        return function() { simplemail.SimpleMailOverlay.openSendContent(fav); }
                                    }(fav), false);
        menupopup.appendChild(menuitem);
        haveFav = true;
      }
    }
    
    if (haveFav)
      menupopup.appendChild(document.createElement("menuseparator"));
    
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", simplemail.SimpleMailBundle.getString("new"));
    menuitem.addEventListener("command", function(){simplemail.SimpleMailOverlay.openSendContent();}, false); 
    menupopup.appendChild(menuitem);
  },

  pub.openSendContent = function(address) {
    var tmessage  = new simplemail.SimpleMailModel.SimpleMailMessage();
    tmessage.to   = address;
    tmessage.html = simplemail.SimpleMailOverlay.getContent(gContextMenu.target);
    if (simplemail.SimpleMailPrefs.getBool("plaintextOnSend"))
      tmessage.html = simplemail.SimpleMailText.linkToText(tmessage.html);

    simplemail.SimpleMailOverlay.openNewMessage(tmessage);
  },

  pub.getContent = function(element) {
    function link(url, title) {
      return simplemail.SimpleMailFile.isLocalURL(url) ? ""
              : "<a href='" + url + "'>" + (title || url) + "</a>";
    }
    
    var doc  = element.ownerDocument;
    var html = simplemail.SimpleMailText.getSelectedHtml(doc);

    if (!html && element.value) { // INPUT & TEXTAREA
      var length = element.selectionEnd - element.selectionStart;
      html = element.value.substr(element.selectionStart, length);
    }
    if (!html && element.nodeName == "IMG")
      html = "<img src='" + element.src + "'>";

    if (html) {
      var link = link(doc.location, doc.title);
      if (link) 
        html += "<br><br>" + simplemail.SimpleMailBundle.getString("infoSource", [link]);
      return html;
    } else if (element.nodeName == "A") {
      return link(element.href, element.innerHTML);
    } else 
      return link(doc.location, doc.title);
  },

  pub.errors    = 0,
  pub.instances = [], // Running GetMail, deleteMail, SendMail instances

  pub.error = function(messageId, params) {
    simplemail.SimpleMailOverlay.errors++;
    simplemail.SimpleMailUtils.error(messageId, params);
  },
  
  // userok: async
  pub.getStatus = function(callbackDone) {
    simplemail.SimpleMailOverlay.storage.getUnreadCount(function(tUnreadCount) { 
      var tstatus = simplemail.SimpleMailOverlay.instances.length ? "loading" :
           simplemail.SimpleMailOverlay.errors ? "errors" :
           tUnreadCount ? "mail" : simplemail.SimpleMailOverlay.lastCheckTime ? "noMail" : "notChecked";
      if (callbackDone)
        callbackDone(tstatus, tUnreadCount);
    });
  },
  
  // userok: async
  pub.updateIcons = function() {
    //console.error("SM.overlay_updateIcons", this);//userok_log
    simplemail.SimpleMailOverlay.getStatus(function(tstatus, tUnreadCount) {
      //console.error("SM.overlay_updateIconsCallback", tstatus, tUnreadCount);//userok_log
      
      simplemail.SimpleMailDom.get("SimpleMailStatusBar-unreadCount").value = tUnreadCount;

      simplemail.SimpleMailDom.get("SimpleMail-status").hidden =
         ((tstatus == "noMail" || tstatus == "loading" || tstatus == "notChecked" ) && simplemail.SimpleMailPrefs.getBool("hideStatusNoMail"))
         || simplemail.SimpleMailPrefs.getBool("hideAll");

      simplemail.SimpleMailDom.get("SimpleMailStatusBar-unreadCount").hidden =
          ((tstatus == "noMail" || tstatus == "loading" || tstatus == "notChecked" ) && simplemail.SimpleMailPrefs.getBool("hideNoMail"))
          || simplemail.SimpleMailPrefs.getBool("hideAll");

      simplemail.SimpleMailDom.get("SimpleMail-icon").setAttribute("SimpleMail-status", tstatus);      
      
      var toolbarButton = simplemail.SimpleMailDom.get("SimpleMail-toolbarbutton");
      if (toolbarButton) {
        simplemail.SimpleMailDom.get("SimpleMailToolbar-unreadCount").value = tUnreadCount;
        simplemail.SimpleMailDom.get("SimpleMailToolbar-unreadCount").hidden = 
          (tstatus == "noMail" || tstatus == "loading" || tstatus == "notChecked" ) && simplemail.SimpleMailPrefs.getBool("hideNoMail");

        toolbarButton.setAttribute("SimpleMail-status", tstatus);
        simplemail.SimpleMailDom.get("SimpleMailToolbar-unreadCount").setAttribute("SimpleMail-status", tstatus);
        simplemail.SimpleMailDom.get("SimpleMailStatusBar-unreadCount").setAttribute("SimpleMail-status", tstatus);
      }

      // userok: updateFavIcon
      var mainWindow = simplemail.SimpleMailOverlay.getMainWindow(true);
      if (mainWindow)
        mainWindow.SimpleMail_updateFavIcon();
      
      if (!simplemail.SimpleMailOverlay.instances.length)
        simplemail.SimpleMailOverlay.errors = 0;      
    });
  },

  pub.updateTooltip = function() {
    var status     = simplemail.SimpleMailDom.get("SimpleMail-icon").getAttribute("SimpleMail-status");
    var timePassed = simplemail.SimpleMailDate.timePassed(simplemail.SimpleMailOverlay.lastCheckTime);
		// userok
		var smtooltip  = simplemail.SimpleMailBundle.getString(status) + (timePassed ? " (" + timePassed + ")" : ""); 
		simplemail.SimpleMailDom.get("SimpleMail-tooltip").label = smtooltip;
		// userok
		var toolbarButton = simplemail.SimpleMailDom.get("SimpleMail-toolbarbutton");
    if (toolbarButton) 
			toolbarButton.setAttribute("tooltiptext", smtooltip);
  },

  pub.lastCheckTime = null,
  pub.timeouts      = [], // Holds timeouts for each account
  
  pub.InstanceListener = function() {
    var _this = this;
    this._instance;

    this.__defineSetter__("instance", function(instance) {
      _this._instance = instance;
      simplemail.SimpleMailOverlay.instances.push(instance);
    });

    this.cleanUp = function() {
      for (var i = 0; i < simplemail.SimpleMailOverlay.instances.length; i++) {
        if (simplemail.SimpleMailOverlay.instances[i] == _this._instance)
          simplemail.SimpleMailOverlay.instances.splice(i, 1);
      }
      simplemail.SimpleMailOverlay.updateIcons();
    };
    
    this.onFinish = function(error) {
      simplemail.SimpleMailOverlay.errors |= error;
      _this.cleanUp();
    }
  },

  // Add to database
  pub.addMessage = function(message) {
    simplemail.SimpleMailOverlay.storage.saveMessage(message);
    var mainWindow = simplemail.SimpleMailOverlay.getMainWindow(true);
    if (mainWindow)
      mainWindow.simplemail.messageTreeView.onMessageAdded(message);
    else
      simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.newMessagesCount = 0,
  pub.finish           = null,

  pub.GetMailListener = function(account) {
    //this.acc = account;//userok_log
    //console.error("SM.GetMailListener", this);//userok_log

    //var se/lf = this; // userok replace_self_this
    this.inheritFrom = simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();
          
    this.existOnServer = [];

    this.messageExists = function(accountId, uid) {
      this.existOnServer[uid] = uid; // userok: replace_self_this
      return simplemail.SimpleMailOverlay.storage.messageExists(accountId, uid);
    }

    this.onMessage = function(message, mailInterface) {
      var LMessage      = message; // userok fix warning
      LMessage.folderId = simplemail.SimpleMailModel.SimpleMailFolder.INBOX;
      var filterManager = new simplemail.SimpleMailModel.SimpleMailFilterManager(simplemail.SimpleMailOverlay.storage, mailInterface);
      
      LMessage = filterManager.execute(LMessage, simplemail.SimpleMailModel.SimpleMailFilter.INBOX);
      
      if (LMessage) {
        if (LMessage.folderId != simplemail.SimpleMailModel.SimpleMailFolder.TRASH) {
          simplemail.SimpleMailOverlay.newMessagesCount++;

          if (simplemail.SimpleMailPrefs.getString("popupNotification") == "onEveryMessage") {
            popup(LMessage.subject, LMessage.from, LMessage.spam);
          }
        }
        simplemail.SimpleMailOverlay.addMessage(LMessage);
  
        if(simplemail.SimpleMailPrefs.getBool("mailSound")){
          var param = simplemail.SimpleMailPrefs.getString("mailSoundPath");
          simplemail.SimpleMailSound.play(param);
        }
        
        if (simplemail.SimpleMailPrefs.getString('forwardParam') !== null) {
          var tfilters = simplemail.SimpleMailOverlay.storage.getFilters();      
          for (var i = 0; LMessage && i < tfilters.length; i++) { 
            var filter = tfilters[i];
            for (var j in filter.rules) {
              if (filter.rules[j].param) {
                for (var k in filter.actions) {
                  var action = filter.actions[k];
                  if (!LMessage.fwd && LMessage.uid && !LMessage.partial && action.name == "forward") {
                    simplemail.messageTreeView.autoForward(LMessage);
                  }
                }
              }
            }     
          }
        }
      }
    }

    function synchronizeIMAP(iself) {
      var messages = simplemail.SimpleMailOverlay.storage.getAccountMessages(account.id);
      var deleted  = [];
      for (var i in messages) {
        var message = messages[i];
        if (message.uid && !iself.existOnServer[message.uid]) { // userok: replace_self_this
          message.uid = "";
          deleted.push(message);
        }
      }
      simplemail.SimpleMailOverlay.dodeleteMessages(deleted);
    }

    function popup(text, title, messageType) {
      if (messageType) {
        messageType = "Spam";
        title = "SPAM - " + title;
      }
      simplemail.SimpleMailPopup.open("chrome://simplemail/skin/status/mail_large.png", title, text, simplemail.SimpleMailOverlay.open, messageType);
    }

    this.onFinish = function(error) {
      //console.error("SM.onFinish", (this == se/lf), this);//userok_log
      if (!error && account.pop3.isImap)
        synchronizeIMAP(this); // userok: replace_self_this

      simplemail.SimpleMailOverlay.errors |= error;
      this.cleanUp(); // userok: replace_self_this

      for(var i = 0; i < simplemail.SimpleMailOverlay.instances.length; i++) {
        if (simplemail.SimpleMailOverlay.instances[i] instanceof simplemail.SimpleMailSocks.SimpleMailGetMail){
        simplemail.SimpleMailOverlay.finish = account;
        return;
        }
      }
      if (simplemail.SimpleMailOverlay.newMessagesCount && simplemail.SimpleMailPrefs.getString("popupNotification") == "summary") {
        var text = simplemail.SimpleMailBundle.getString("newMessages", [simplemail.SimpleMailOverlay.newMessagesCount]);
        popup(text, "Simple Mail");
      }
      simplemail.SimpleMailOverlay.newMessagesCount = 0;
    }
    simplemail.SimpleMailPrefs.clear('forwardParam'); // Clean up temporary prefs
  },

  pub.getMail = function(accountId) {
    simplemail.SimpleMailOverlay.lastCheckTime = new Date();
    var taccounts = simplemail.SimpleMailOverlay.storage.getAccounts();
    for (var i = 0, j = taccounts.length; i < j; i++) {
      var account = taccounts[i];
        
      if (!account.pop3.host || (accountId && account.id != accountId)) 
        continue;
      if (!accountId && account.refresh < 0) 
        continue;

      simplemail.SimpleMailCheck.open(account);

      clearTimeout(simplemail.SimpleMailOverlay.timeouts[account.id]);
      if (account.refresh > 0) {
        // userok
        simplemail.SimpleMailOverlay.timeouts[account.id] =
          setTimeout(function(accId) {
            //console.error("SM.getMail.accId: ", accId);//userok
            simplemail.SimpleMailOverlay.getMail(accId);
          }, account.refresh * 60 * 1000, account.id);
      }
        
      if (account.pop3.isImap) {
        var messages = simplemail.SimpleMailOverlay.storage.getAccountMessages(account.id);
        simplemail.SimpleMailOverlay.SynchroMail(account, messages, "inbox", "");
      }
      simplemail.SimpleMailOverlay.updateIcons();
    }
  },

  pub.groupByAccounts = function(messages) {
    var grouped = [];
    for (var i in messages) {
      var message = messages[i];
      if (!grouped[message.accountId])
        grouped[message.accountId] = [];

      grouped[message.accountId][message.id] = message;
    }
    return grouped;
  },

  // Delete from database // userok: async
  pub.dodeleteMessages = function(messages) {
    for (var i in messages)
      simplemail.SimpleMailOverlay.storage.deleteMessage(0, messages[i]); // userok: async

    var mainWindow = simplemail.SimpleMailOverlay.getMainWindow(true);
    if (mainWindow)
      mainWindow.simplemail.messageTreeView.onMessagesDeleted(messages)
    else
      simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.askDeleteMail = function(messages, confirmText, wnd, onDelete) {
    function confirmDelete(confirmText, server) {
      if (simplemail.SimpleMailPrefs.getBool("confirmdelete")) {
        var check  = { value: simplemail.SimpleMailPrefs.getBool("deleteFromServer") };
        var result = !server ? simplemail.SimpleMailUtils.confirm(confirmText, wnd)
                             : simplemail.SimpleMailUtils.confirmCheck(confirmText, simplemail.SimpleMailBundle.getString("deleteFromServer"), check, wnd);
        
        if (result) 
          simplemail.SimpleMailPrefs.setBool("deleteFromServer", check.value);
        
        return { delete: result, server: check.value };
      } else
        return { delete: true, server: true };
    }
    
    var grouped = [];
    for (var i in messages) {
      var message = messages[i];
      var deleteMode = simplemail.SimpleMailModel.SimpleMailAccount.NEVER;
      if (message.uid) {
        var account = simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
        if (account) 
          deleteMode = account.deleteMode;
      }
      
      if (deleteMode == simplemail.SimpleMailModel.SimpleMailAccount.ON_RECEIVE)
        deleteMode = message.partial ? simplemail.SimpleMailModel.SimpleMailAccount.ASK : simplemail.SimpleMailModel.SimpleMailAccount.NEVER;

      if (!grouped[deleteMode]) 
        grouped[deleteMode] = [];
      grouped[deleteMode].push(message);
    }

    var confirm = confirmDelete(confirmText, grouped[simplemail.SimpleMailModel.SimpleMailAccount.ASK]);
    if (!confirm.delete) 
      return;

    var deleteMode = confirm.server ? simplemail.SimpleMailModel.SimpleMailAccount.ALWAYS : simplemail.SimpleMailModel.SimpleMailAccount.NEVER;
    grouped[deleteMode] = (grouped[deleteMode] || []).concat(grouped[simplemail.SimpleMailModel.SimpleMailAccount.ASK] || []);

    simplemail.SimpleMailOverlay.dodeleteMessages(grouped[simplemail.SimpleMailModel.SimpleMailAccount.NEVER]);
    simplemail.SimpleMailOverlay.deleteMail(grouped[simplemail.SimpleMailModel.SimpleMailAccount.ALWAYS], onDelete);
  },

  pub.DeleteMailListener = function(onDelete) {
    var _this = this;
    this.inheritFrom = simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();

    this.onFinish = function(error, deleted) {
      simplemail.SimpleMailOverlay.dodeleteMessages(deleted);
      if (onDelete) 
        onDelete();

      simplemail.SimpleMailOverlay.errors |= error;
      _this.cleanUp();
    }
  },

  pub.deleteMail = function(messages, onDelete) {
    if (!messages || !messages.length) {
      if (onDelete) 
        onDelete();
      return;
    }
    
    messages = simplemail.SimpleMailOverlay.groupByAccounts(messages);
    for (var accountId in messages) {
      var account = simplemail.SimpleMailOverlay.storage.getAccount(accountId);
      if (!account) 
        simplemail.SimpleMailOverlay.error("accountNoLongerExist");
      else {
        var listener      = new simplemail.SimpleMailOverlay.DeleteMailListener(onDelete);
        listener.instance = new simplemail.SimpleMailSocks.SimpleMailDeleteMail(account, listener, messages[accountId]).execute();
      }
    }
    
    simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.SendMailListener = function(message, onSend) {
    var kself = this;
    this.inheritFrom = simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();

    this.onFinish = function(error) {
      if (!error) {
        message.folderId = simplemail.SimpleMailModel.SimpleMailFolder.SENT;
        message.read = true;
        var account = simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);

        var filterManager = new simplemail.SimpleMailModel.SimpleMailFilterManager(simplemail.SimpleMailOverlay.storage, {
          getBody: function(msg) {},
          delete: function(msg) {
            simplemail.SimpleMailOverlay.dodeleteMessages([msg]);
          }
        });

        if (account.pop3.isImap) {
          var folder   = "sent";
          var messages = [];       
          messages.push(message);
          simplemail.SimpleMailOverlay.SynchroMail(account, messages, folder, "");
        }

        if (simplemail.SimpleMailPrefs.getBool("addressBookAddOnSend")) {
          var recipients = message.to + "," + message.cc + "," + message.bcc;
          // userok: async
          simplemail.SimpleMailOverlay.storage.addAddressList(function(taddr) {
            simplemail.addressTreeView.treebox.rowCountChanged(simplemail.addressTreeView.rowCount - 1, 1);
          }, recipients);
        }
        
        if (message && simplemail.SimpleMailPrefs.getString('forwardParam')) {
          message = filterManager.execute(message, simplemail.SimpleMailModel.SimpleMailFilter.SENT);
          simplemail.SimpleMailOverlay.storage.saveMessage(message);
        }
        
        if (message && simplemail.SimpleMailPrefs.getString('forwardParam') == null) {
          message = filterManager.execute(message, simplemail.SimpleMailModel.SimpleMailFilter.SENT); 
          message.to = simplemail.SimpleMailPrefs.getString('originalTo');
          message.cc = simplemail.SimpleMailPrefs.getString('originalCc');
          message.bcc = simplemail.SimpleMailPrefs.getString('originalBcc');
          simplemail.SimpleMailOverlay.addMessage(message);
                         
          if (message.subject.match(/^(Re:)/i)){
            var originalId = simplemail.SimpleMailPrefs.getString('originalId');
            var messageOri = simplemail.SimpleMailOverlay.storage.getMessage(originalId);
            if (typeof(messageOri) == 'undefined'){
              var messageOri = message;
            }
            messageOri.replied = true;
            simplemail.SimpleMailOverlay.storage.saveMessageState(messageOri);
            if (messageOri.replied) {
              var account  = simplemail.SimpleMailOverlay.storage.getAccount(messageOri.accountId);
              var messages = [];
              messages.push(messageOri);
              simplemail.SimpleMailOverlay.SynchroMail(account, messages, folder, "Answered");
            }
          }
          if (message.subject.match(/^(Fwd:)/i)){
            var originalId = simplemail.SimpleMailPrefs.getString('originalId');
            var messageOri = simplemail.SimpleMailOverlay.storage.getMessage(originalId);
            if (typeof(messageOri) == 'undefined')
              var messageOri = message;
            messageOri.fwd = true;
            simplemail.SimpleMailOverlay.storage.saveMessageState(messageOri);
          }
          simplemail.SimpleMailPrefs.clear('forwardParam'); // Clean up temporary prefs
        }

        if (onSend) {
          onSend();
          var textsent = message.subject + " - " + simplemail.SimpleMailBundle.getString("messagesent");
          var account = simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
          simplemail.SimpleMailPopup.open("chrome://simplemail/skin/status/mail_large.png", "Simple Mail - " + account, textsent);
        }
      }

      simplemail.SimpleMailOverlay.errors |= error;
      kself.cleanUp();

      simplemail.SimpleMailPrefs.clear('originalId');
      simplemail.SimpleMailPrefs.clear('originalTo');
      simplemail.SimpleMailPrefs.clear('originalCc');
      simplemail.SimpleMailPrefs.clear('originalBcc');
    }
  },
  
  pub.autosendMail = function(message, onSend) { 
    var account = simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
    if (!account) 
      simplemail.SimpleMailOverlay.error("accountNoLongerExist");
    else {
      var listener      = new simplemail.SimpleMailOverlay.SendMailListener(message, onSend);
      listener.instance = new simplemail.SimpleMailSocks.SimpleMailSendMail(account, listener, message).execute();
    }
    simplemail.SimpleMailOverlay.updateIcons();
  },
      
  pub.sendMail = function(message, onSend) {
    var account = simplemail.SimpleMailOverlay.storage.getAccount(message.accountId);
    simplemail.SimpleMailPrefs.setString('accountError', account.name);
    if (!account) 
      simplemail.SimpleMailOverlay.error("accountNoLongerExist");
    else {
      var listener = new simplemail.SimpleMailOverlay.SendMailListener(message, onSend);
      listener.instance = new simplemail.SimpleMailSocks.SimpleMailSendMail(account, listener, message).execute();
      
      var gBrowser = simplemail.SimpleMailUtils.getBrowser();
      for(var i = 0; i < gBrowser.browsers.length; i++) {
        var browser = gBrowser.browsers[i];
        var uri = browser.currentURI.spec.replace (/(\?).*?/ig, "");
        var uri = uri.replace(/([0-9]).*?/ig, "");
        if (uri == "chrome://simplemail/content/newmessage.xul") {
          simplemail.SimpleMailOverlay.mailTab = browser.contentWindow.wrappedJSObject;
        }
      }
      
      function cancelSend () {
        var win = simplemail.SimpleMailOverlay.mailTab;
        if (typeof(win) == 'undefined')
          var win = simplemail.SimpleMailOverlay.mailWindow;

        if (win == null)
          var win = browser.contentWindow.wrappedJSObject;

        win.document.getElementById("cancelsend").value = "cancelsend";
      }

      function setProgress(counter) {
        var win = simplemail.SimpleMailOverlay.mailTab;
        if (typeof(win) == 'undefined') {
          var win = simplemail.SimpleMailOverlay.mailWindow;
        }
        if (win == null) {
          var win = browser.contentWindow.wrappedJSObject;
        }
        var progressMeter = win.document.getElementById("progressMeter");
        progressMeter.value = counter;
      }
      
      function endSend() {
        var win = simplemail.SimpleMailOverlay.mailTab;
        if (typeof(win) == 'undefined') {
          var win = simplemail.SimpleMailOverlay.mailWindow;
        }
        if (win == null) {
          var win = browser.contentWindow.wrappedJSObject;
        }
        clearTimeout(timeoutID);
        if (win !== null) {
          win.document.getElementById("cancelsend").value = "";
          win.document.getElementById("cancelsend").hidden=true;
          win.document.getElementById("cancelsend").removeEventListener ('click', cancelSend, false);
          win.document.getElementById("progressMeter").collapsed=true;
          win.document.getElementById("progressMeterText").value = "";
          win.document.getElementById("progressMeterText").hidden=true;
        }
      }

      function timeout(counter) {
        var win  = simplemail.SimpleMailOverlay.mailTab;
        var buttoncancelsend = win.document.getElementById("cancelsend");
        buttoncancelsend.addEventListener('click', cancelSend, false);
        
        //var stat = simplemail.SimpleMailOverlay.get/Status();                // userok  
        //if (stat !== "loading" || buttoncancelsend.value == "cancelsend") { // userok
        if (!simplemail.SimpleMailOverlay.instances.length || buttoncancelsend.value == "cancelsend") {   // userok
          if (buttoncancelsend.value == "cancelsend") {
            simplemail.SimpleMailOverlay.stop();
            endSend();
          } else
            endSend();
        } else {
          counter = counter+5;
          if (counter == 100)
            counter = 0;
          
          setProgress(counter);
          var timeoutID = setTimeout(function() { 
            timeout(counter);
          }, 100);
        }
      }

      var counter = 10;
      setProgress(counter);
      var timeoutID = setTimeout(function() { 
        timeout(counter);
      }, 100);

      var win = simplemail.SimpleMailOverlay.mailTab;
      if (typeof(win) == 'undefined')
        var win = simplemail.SimpleMailOverlay.mailWindow;

      win.document.getElementById("cancelsend").hidden        = false;
      win.document.getElementById("progressMeter").collapsed  = false;
      win.document.getElementById("progressMeterText").hidden = false;
      win.document.getElementById("progressMeterText").value  = account.name;
    }
    
    simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.GetMailBodyListener = function(messages) {
    // userok: what for? var se/lf = this;
    this.inheritFrom = simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();

    this.onMessage = function(message) {
      var LMessage = message; // userok fix warning
      var old      = messages[LMessage.id];
      simplemail.SimpleMailFile.deleteAttachments(old.attachmentsDir);
      LMessage = simplemail.SimpleMailUtils.merge(old, LMessage);

      simplemail.SimpleMailOverlay.storage.saveMessage(LMessage);
      var mainWindow = simplemail.SimpleMailOverlay.getMainWindow(true);
      if (mainWindow) 
        mainWindow.simplemail.messageTreeView.onMessageUpdated(LMessage);
    }
  },

  pub.getMailBody = function(messages) {
    messages = simplemail.SimpleMailOverlay.groupByAccounts(messages);
    for (var accountId in messages) {
      var account = simplemail.SimpleMailOverlay.storage.getAccount(accountId);
      if (!account) 
        simplemail.SimpleMailOverlay.error("accountNoLongerExist");
      else {
        var listener = new simplemail.SimpleMailOverlay.GetMailBodyListener(messages[accountId]);
        listener.instance = new simplemail.SimpleMailSocks.SimpleMailGetMailBody(account, listener, messages[accountId]).execute();
      }
    }
    simplemail.SimpleMailOverlay.updateIcons();
  },

  pub.SynchroMailListener = function(account, messages, folder, flag) {
    var _this = this;
    this.inheritFrom = simplemail.SimpleMailOverlay.InstanceListener;
    this.inheritFrom();

    this.existOnServer = [];

    this.messageExists = function(accountId, uid) {
      _this.existOnServer[uid] = uid;
      return simplemail.SimpleMailOverlay.storage.messageExists(accountId, uid);
    }
    
    this.onMessage = function(message) {
    }
    
    this.onFinish = function(error) {
      simplemail.SimpleMailOverlay.errors |= error;
      _this.cleanUp();
    }
  },

  pub.SynchroMail = function(account, messages, folder, flag) {
    if (typeof(account) !== 'undefined') {
      if (account.pop3.isImap) {
        var listener = new simplemail.SimpleMailOverlay.SynchroMailListener(account, messages, folder, flag);
        listener.instance = new simplemail.SimpleMailSocks.SimpleMailSynchroMail(account, listener, messages, folder, flag).execute();
      }
      simplemail.SimpleMailOverlay.updateIcons();
    }
  }
  
  return pub;
}();

// start
//console.error("SM.overlay", this);//userok_log
addEventListener("load", simplemail.SimpleMailOverlay.preinitialize, false); // userok: async

simplemail.SimpleMailCheck = function () {
  var pub = {};
  
  pub.queue = [],
  pub.inProgress = false,
  pub.timeoutID = [],

  pub.setProgress = function(counter) {
   var win = simplemail.SimpleMailOverlay.getMainWindow();
   var progressMeter = win.document.getElementById("progressMeter");
   progressMeter.value = counter;
  }, 

  pub.cancelCheck = function(event) {
    var win = simplemail.SimpleMailOverlay.getMainWindow();
    win.document.getElementById("cancelcheck").value = "cancelcheck";
  },

  pub.open = function(accountItem) {
    simplemail.SimpleMailCheck.queue.push({ accountItem: accountItem });
    simplemail.SimpleMailCheck.showNext();
  },

  pub.showNext = function() {
    if (simplemail.SimpleMailCheck.inProgress) 
      return;
    
    var item = simplemail.SimpleMailCheck.queue.shift();
    if (!item) 
      return;

    simplemail.SimpleMailPrefs.setString('accountError', item.accountItem);

    var listener      = new simplemail.SimpleMailOverlay.GetMailListener(item.accountItem);
    listener.instance = new simplemail.SimpleMailSocks.SimpleMailGetMail(item.accountItem, listener, simplemail.SimpleMailPrefs.getBool("headersOnly")).execute();
    
    simplemail.SimpleMailCheck.inProgress = true;

    var actualWindow = simplemail.SimpleMailOverlay.testTabUrl("chrome://simplemail/content/main/main.xul");
    if (actualWindow) {
      var win = simplemail.SimpleMailOverlay.getMainWindow();
      win.document.getElementById("progressMeter").collapsed  = false; 
      win.document.getElementById("cancelcheck").hidden       = false;
      win.document.getElementById("progressMeterText").hidden = false;
      win.document.getElementById("progressMeterText").value  = item.accountItem;
      var counter = 10;
    }
    simplemail.SimpleMailOverlay.updateIcons();
    simplemail.SimpleMailCheck.show(item, counter);
  },

  pub.show = function(item, counter) {
    var actualWindow = simplemail.SimpleMailOverlay.testTabUrl("chrome://simplemail/content/main/main.xul");
    
    if (actualWindow) {
      var win = simplemail.SimpleMailOverlay.getMainWindow();
      win.document.getElementById("cancelcheck").addEventListener('click', simplemail.SimpleMailCheck.cancelCheck, false);
      simplemail.SimpleMailCheck.setProgress(counter);
  
      win.document.getElementById("progressMeterText").value = item.accountItem;
                   
      if (win.document.getElementById("cancelcheck").value == "cancelcheck") {
        simplemail.SimpleMailOverlay.stop();
        setTimeout(function() {
          endCheck();
        }, 10);
      }
    }
    
    //var stat = simplemail.SimpleMailOverlay.get/Status(); // userok
    //if (stat !== "loading") {                            // userok
    if (!simplemail.SimpleMailOverlay.instances.length) {  // userok
      setTimeout(function() {
        endCheck();
      }, 10);
    }

    if (simplemail.SimpleMailOverlay.finish == item.accountItem) {
      simplemail.SimpleMailCheck.inProgress = false;
      simplemail.SimpleMailCheck.showNext();
    }

    counter = counter + 5;
    if (counter == 105)
      counter = 0;

    simplemail.SimpleMailCheck.timeoutID[item] = setTimeout(function() {
        simplemail.SimpleMailCheck.show(item,counter);
      }, 100);

    function endCheck() {
      clearTimeout(simplemail.SimpleMailCheck.timeoutID[item]);
      if (actualWindow) {
        win.document.getElementById("cancelcheck").value        = "";
        win.document.getElementById("cancelcheck").hidden       = true;
        win.document.getElementById("progressMeter").collapsed  = true;
        win.document.getElementById("progressMeterText").value  = "";
        win.document.getElementById("progressMeterText").hidden = true;
        win.document.getElementById("cancelcheck").removeEventListener('click', simplemail.SimpleMailCheck.cancelCheck, false); 
      }
      
      simplemail.SimpleMailCheck.inProgress = false;
      simplemail.SimpleMailPrefs.clear('accountError');
      simplemail.SimpleMailCheck.showNext();
    }
  }
  
  return pub;
}();