// Pre-load due to asynchronous callback in AddonManager
var dirLocation = simplemail.SimpleMailFile.getExtensionDirectory();
var account     = window.arguments[0].inn.account;

function initialize() {
  document.title = (account.id) ? simplemail.SimpleMailBundle.getString("editAccount", [account])
                                : simplemail.SimpleMailBundle.getString("newAccount");

  getValues(account);
}

//userok function checkValues(txtBox, evt) {
function checkValues(txtBox) {
	var accountEmail = account.email;
	if (accountEmail)
		accountEmail = accountEmail.toLowerCase();

	simplemail.SimpleMailOverlay = simplemail.SimpleMailUtils.getBrowserWindow().simplemail.SimpleMailOverlay;
	var taccounts = simplemail.SimpleMailOverlay.storage.getAccounts();
	document.getElementById('email').value = txtBox.value;
	for (var i in taccounts) {
		if (taccounts[i].email.toLowerCase() == txtBox.value.toLowerCase() && txtBox.value.toLowerCase() !== accountEmail) {
			var confirmText = simplemail.SimpleMailBundle.getString("accountAlert");
			simplemail.SimpleMailUtils.alert(confirmText);
			setTimeout(function() {
				document.getElementById('email').focus();
			}, 0);
			account.email = accountEmail;
			txtBox.value  = accountEmail;
			//userok       evt.preventDefault();
			//userok       document.documentElement.getButton("accept").addEventListener("click", event.preventDefault(), false);
			//userok
			return false;
		}
	}

	if (!txtBox.value.toLowerCase().match(/^[a-z0-9._%+-]+@(?:[a-z0-9-])/gim)) {
		var confirmText = simplemail.SimpleMailBundle.getString("addressAlert");
		simplemail.SimpleMailUtils.alert(confirmText);
		setTimeout(function() {
			document.getElementById('email').focus();
		}, 0);
		if (accountEmail) {
			account.email = accountEmail;
			txtBox.value = accountEmail;
		} else {
			account.email = null;
			txtBox.value = "someone@somewhere.com";
		}
		//userok     evt.preventDefault();
		//userok     document.documentElement.getButton("accept").addEventListener("click", event.preventDefault(), false);
		//userok
		return false;
	}
	//userok
	return true;
}

function getValues(account) {
  simplemail.SimpleMailDom.get("name").value      = account.name;
  simplemail.SimpleMailDom.get("email").value     = account.email;
  simplemail.SimpleMailDom.get("replyTo").value   = account.replyTo;
  simplemail.SimpleMailDom.get("refresh").value   = account.refresh;
  simplemail.SimpleMailDom.get("subject").value   = account.subject;
  simplemail.SimpleMailDom.get("signature").value = account.signature;
  simplemail.SimpleMailUtils.selectItem("deleteMode", account.deleteMode);
  
  simplemail.SimpleMailDom.get("isImap").selectedIndex    = account.pop3.isImap || 0;
  simplemail.SimpleMailDom.get("pop3auth").selectedIndex  = account.pop3.auth || 0;
  simplemail.SimpleMailDom.get("pop3host").value          = account.pop3.host;
  simplemail.SimpleMailDom.get("pop3port").value          = account.pop3.port;
  simplemail.SimpleMailDom.get("pop3ssl").checked         = account.pop3.ssl;
  simplemail.SimpleMailDom.get("pop3login").value         = account.pop3.login;
  simplemail.SimpleMailDom.get("pop3password").value      = account.pop3.getPassword();

  simplemail.SimpleMailDom.get("onreceive").disabled = simplemail.SimpleMailDom.get("isImap").selectedIndex ? true : false;

  simplemail.SimpleMailDom.get("smtpHost").value     = account.smtp.host;
  simplemail.SimpleMailDom.get("smtpPort").value     = account.smtp.port;
  simplemail.SimpleMailDom.get("smtpSsl").checked    = account.smtp.ssl;
  simplemail.SimpleMailDom.get("smtpTls").checked    = account.smtp.tls;  
  simplemail.SimpleMailDom.get("smtpLogin").value    = account.smtp.login;
  simplemail.SimpleMailDom.get("smtpPassword").value = account.smtp.getPassword();
  simplemail.SimpleMailDom.get("smtpAuth").checked   = account.smtp.auth;

  simplemail.SimpleMailDom.get("email").addEventListener("change", function(event) {
    var address = simplemail.SimpleMailModel.SimpleMailAddress.parse(event.target.value);
    simplemail.SimpleMailDom.get("pop3host").value  = "pop."  + address.getHost();
    simplemail.SimpleMailDom.get("smtpHost").value  = "smtp." + address.getHost();
    simplemail.SimpleMailDom.get("pop3login").value = address.getLogin() + "@" + address.getHost();
    simplemail.SimpleMailDom.get("smtpLogin").value = address.getLogin() + "@" + address.getHost();

    // Presets for specific hosts
    switch (address.getHost()) {
      case "gmail.com":
          simplemail.SimpleMailDom.get("isImap").selectedIndex = 1;
          simplemail.SimpleMailDom.get("pop3host").value       = "imap.gmail.com";
          simplemail.SimpleMailDom.get("pop3ssl").checked      = true;
          simplemail.SimpleMailDom.get("smtpSsl").checked      = true;
          simplemail.SimpleMailDom.get("smtpTls").checked      = false;
          simplemail.SimpleMailDom.get("pop3port").value       = 993;
          simplemail.SimpleMailDom.get("smtpPort").value       = 465;
          break;
      case "gmx.com":
          simplemail.SimpleMailDom.get("isImap").selectedIndex = 1;
          simplemail.SimpleMailDom.get("pop3host").value       = "imap.gmx.com";
          simplemail.SimpleMailDom.get("smtpHost").value       = "mail.gmx.com";
          simplemail.SimpleMailDom.get("pop3ssl").checked      = true;
          simplemail.SimpleMailDom.get("smtpSsl").checked      = true;
          simplemail.SimpleMailDom.get("smtpTls").checked      = false;
          simplemail.SimpleMailDom.get("pop3port").value       = 993;
          simplemail.SimpleMailDom.get("smtpPort").value       = 465;
          break;
      case "gmx.de":
          simplemail.SimpleMailDom.get("isImap").selectedIndex = 1;
          simplemail.SimpleMailDom.get("pop3host").value       = "imap.gmx.net";
          simplemail.SimpleMailDom.get("smtpHost").value       = "mail.gmx.net";
          simplemail.SimpleMailDom.get("pop3ssl").checked      = true;
          simplemail.SimpleMailDom.get("smtpSsl").checked      = true;
          simplemail.SimpleMailDom.get("smtpTls").checked      = false;
          simplemail.SimpleMailDom.get("pop3port").value       = 993;
          simplemail.SimpleMailDom.get("smtpPort").value       = 465;
          break;
      case "hotmail.com":
          simplemail.SimpleMailDom.get("isImap").selectedIndex = 1;
          simplemail.SimpleMailDom.get("pop3host").value       = "imap3.live.com";
          simplemail.SimpleMailDom.get("smtpHost").value       = "smtp.live.com";
          simplemail.SimpleMailDom.get("pop3ssl").checked      = true;
          simplemail.SimpleMailDom.get("smtpSsl").checked      = true;
          simplemail.SimpleMailDom.get("smtpTls").checked      = false;
          simplemail.SimpleMailDom.get("pop3port").value       = 993;
          simplemail.SimpleMailDom.get("smtpPort").value       = 465;
          break;
      case "localhost":
          simplemail.SimpleMailDom.get("pop3host").value = "localhost";
          simplemail.SimpleMailDom.get("smtpHost").value = "localhost";
          break;
    }
  }, false);

  function updatePop3Port() {
    var ssl = simplemail.SimpleMailDom.get("pop3ssl").checked;
    simplemail.SimpleMailDom.get("pop3port").value =
      simplemail.SimpleMailDom.get("isImap").selectedIndex ? (ssl ? 993 : 143) : (ssl ? 995 : 110);
  }

  simplemail.SimpleMailDom.get("pop3ssl").addEventListener("command", updatePop3Port, false);
  simplemail.SimpleMailDom.get("isImap").addEventListener("command", function(event) {
    updatePop3Port();
    simplemail.SimpleMailDom.get("pop3host").value = simplemail.SimpleMailDom.get("isImap").selectedIndex
      ? simplemail.SimpleMailDom.get("pop3host").value.replace(/^pop/, "imap")
      : simplemail.SimpleMailDom.get("pop3host").value.replace(/^imap/, "pop");

    if (simplemail.SimpleMailDom.get("isImap").selectedIndex) {
      simplemail.SimpleMailDom.get("onreceive").disabled = true;
      simplemail.SimpleMailUtils.selectItem("deleteMode", "never");
      simplemail.SimpleMailDom.get("deleteMode").selectedItem.value = "never";
    } else {
      simplemail.SimpleMailDom.get("onreceive").disabled = false;
      simplemail.SimpleMailUtils.selectItem("deleteMode", account.deleteMode);
      simplemail.SimpleMailDom.get("deleteMode").selectedItem.value = account.deleteMode;
    }
  }, false);

  simplemail.SimpleMailDom.get("smtpSsl").addEventListener("command", function(event) {
    simplemail.SimpleMailDom.get("smtpPort").value = event.target.checked ? 465 : 25;
    if (simplemail.SimpleMailDom.get("smtpSsl").checked)
      simplemail.SimpleMailDom.get("smtpTls").checked = false;
  }, false);
  
  simplemail.SimpleMailDom.get("smtpTls").addEventListener("command", function(event) {
    simplemail.SimpleMailDom.get("smtpPort").value = event.target.checked ? 587 : 25;
    if (simplemail.SimpleMailDom.get("smtpTls").checked)
      simplemail.SimpleMailDom.get("smtpSsl").checked = false;
  }, false);
  
  setColor(account.color || "00.png");
}

function populateEnv() {
  var ICONS_PER_ROW = 5;
  var dirLocation   = simplemail.SimpleMailFile.getEnvDirectory();     

  var hbox, i = 0;
  var menupopup = simplemail.SimpleMailDom.get("color").firstChild;
  simplemail.SimpleMailUtils.clearElement(menupopup);

  simplemail.SimpleMailFile.forEachFile(dirLocation, function(file) {
    var image = document.createElement("image");
    image.setAttribute("src", simplemail.SimpleMailFile.getEnvelopeIconURL(file.leafName));
    image.value = file.leafName;

    if (i++ % ICONS_PER_ROW == 0) {
      hbox = document.createElement("hbox");
      menupopup.appendChild(hbox);
    }
    hbox.appendChild(image);
  });
}

function setColor(value) {
  if (!value) 
    return;

  var color   = simplemail.SimpleMailDom.get("color");
  color.image = simplemail.SimpleMailFile.getEnvelopeIconURL(value);
  color.value = value;
  color.firstChild.hidePopup();
}

function onAccept() {
	//userok
	if (!checkValues(simplemail.SimpleMailDom.get("email")))
		return false;

	account.name = simplemail.SimpleMailDom.get("name").value;
	account.email = simplemail.SimpleMailDom.get("email").value;
//userok var evt = document.createEvent("MouseEvents");
//userok evt.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
//userok var cb = document.documentElement.getButton("accept");
//userok cb.addEventListener("click", checkValues(simplemail.SimpleMailDom.get("email"), evt), false);
	account.replyTo = simplemail.SimpleMailDom.get("replyTo").value;
	account.refresh = simplemail.SimpleMailDom.get("refresh").value;
	if (simplemail.SimpleMailDom.get("isImap").selectedIndex && account.deleteMode == "onreceive")
		account.deleteMode = "never"
	else
		account.deleteMode = simplemail.SimpleMailDom.get("deleteMode").selectedItem.value;

	account.subject = simplemail.SimpleMailDom.get("subject").value;
	account.signature = simplemail.SimpleMailDom.get("signature").value;

	account.pop3.isImap = simplemail.SimpleMailDom.get("isImap").selectedIndex;
	account.pop3.auth = simplemail.SimpleMailDom.get("pop3auth").selectedIndex;
	account.pop3.host = simplemail.SimpleMailDom.get("pop3host").value;
	account.pop3.port = simplemail.SimpleMailDom.get("pop3port").value;
	account.pop3.ssl = simplemail.SimpleMailDom.get("pop3ssl").checked;
	account.pop3.login = simplemail.SimpleMailDom.get("pop3login").value;
	account.pop3.password = simplemail.SimpleMailDom.get("pop3password").value;

	account.smtp.host = simplemail.SimpleMailDom.get("smtpHost").value;
	account.smtp.port = simplemail.SimpleMailDom.get("smtpPort").value;
	account.smtp.ssl = simplemail.SimpleMailDom.get("smtpSsl").checked;
	account.smtp.tls = simplemail.SimpleMailDom.get("smtpTls").checked;  
	account.smtp.login = simplemail.SimpleMailDom.get("smtpLogin").value;
	account.smtp.password = simplemail.SimpleMailDom.get("smtpPassword").value;
	account.smtp.auth = simplemail.SimpleMailDom.get("smtpAuth").checked;
	account.color = simplemail.SimpleMailDom.get("color").value;
	window.arguments[0].out = {account:account};

	//userok
	return true;
}

function onCancel() {
  if (simplemail.SimpleMailDom.get("isImap").selectedIndex) {
    if (account.deleteMode == "onreceive")
      account.deleteMode = "never";
  }
}