if (typeof(simplemail) == "undefined" ) {simplemail = {};};

function initRules(aRules, aType) {
  simplemail.rules         = aRules;
  simplemail.ruleType      = aType;
  simplemail.ruleTree      = simplemail.SimpleMailDom.get("rule-tree");
  simplemail.ruleTree.view = ruleTreeView;
  if (simplemail.ruleTree.view.rowCount > 0) 
    simplemail.ruleTree.view.selection.select(0);
}

var ruleTreeView = {
  get rowCount() {
    return simplemail.rules.length;
  },
  getCellText: function(row, column) {
    var name  = column.id.replace(/rule-/, "");
    var value = simplemail.rules[row][name];
    switch(name) {
      case "not":
        value = value ? "not" : "";
        break;
      case "param":
        var property = simplemail.rules[row]["property"];
        switch(property) {
          case "size":
            value = simplemail.SimpleMailUtils.size2string(value);
            break;
          case "accountId":
            value = simplemail.SimpleMailOverlay.storage.getAccount(value);
            break;
        }
        break;
    }
    return simplemail.SimpleMailBundle.getString(value) || value;
  },
  action: editRule,
  delete: deleteRules
};
simplemail.DefaultTreeView.extend(ruleTreeView);

function onSelectRule() {
  simplemail.SimpleMailDom.get("rule-edit").disabled =
  simplemail.SimpleMailDom.get("rule-delete").disabled = !simplemail.ruleTree.view.selection.getRangeCount();
}

function editRule(add) {
  var rule  = add ? simplemail.SimpleMailModel.SimpleMailRule.create(simplemail.ruleType) : simplemail.rules[simplemail.ruleTree.currentIndex];
  var param = { rule: rule };

  openDialog("chrome://simplemail/content/preferences/filter/rule.xul",
             "simplemail-preferences-filter-rule-window",
             "chrome,centerscreen,modal,resizable", param);
  if (!param.rule) return;

  if (add) {
    simplemail.rules.push(rule);
    ruleTreeView.treebox.rowCountChanged(ruleTreeView.rowCount - 1, 1);
    simplemail.ruleTree.view.selection.select(ruleTreeView.rowCount - 1);
  } else {
    ruleTreeView.treebox.invalidateRow(simplemail.ruleTree.currentIndex);
  }
}

function deleteRules() {
  if (simplemail.SimpleMailUtils.confirm(simplemail.SimpleMailBundle.getString("deleteRule"))) {
    ruleTreeView.forEachSelected(function(index) {
      simplemail.rules.splice(index, 1);
      ruleTreeView.treebox.rowCountChanged(index, -1);
    });
  }
}
