if (typeof(simplemail) == "undefined" ) {simplemail = {};};

simplemail.SimpleMailPassword = function() {
  var pub = {};

  pub.SimpleMailLoginManagerImpl = function() { // Firefox >= 3.0
    var loginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
    var nsLoginInfo  = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
    var url          = "chrome://simplemail/";
    var realm        = "Simple Mail Account Password";
    var userName     = "simplemail";
  
    this.getPassword = function(id) {
      var logins = loginManager.findLogins({}, url + id, null, realm);
        
      for (var i = 0; i < logins.length; i++) {
        if (logins[i].username == userName)
          return logins[i].password;
      }
      
      return "";
    }
  
    this.removePassword = function(id) {
      var logins = loginManager.findLogins({}, url + id, null, realm);
      for (var i = 0; i < logins.length; i++) {
        if (logins[i].username == userName) {
           loginManager.removeLogin(logins[i]);
           return;
        }
      }
    }
  
    this.setPassword = function(id, password) {
      this.removePassword(id);
      if (!password) 
        return;
  
      try {
        var loginInfo = new nsLoginInfo(url + id, null, realm, userName, password, "", "");
        loginManager.addLogin(loginInfo);
      } catch(e) {}
    }
  }

  return pub;
}();

simplemail.PasswordManager = new simplemail.SimpleMailPassword.SimpleMailLoginManagerImpl();

simplemail.SimpleMailStorageManager = function() {
  var pub = {};

  pub.SimpleMailStorage = function() {
    //console.error("SM.SimpleMailStorage", this);//userok_log
    
    var file           = simplemail.SimpleMailFile.getDataDirectory();
    file.append("simplemail.sqlite");
    
    this.firstRun      = !file.exists();
    var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);
    var connection     = storageService.openDatabase(file);
    
    // userok: async
    this.initStorage = function(callbackDone) {
      //console.error("SM.initStorage", this);//userok_log
          
      if (this.firstRun) {
        var arrStatements = [];

        arrStatements.push(connection.createAsyncStatement("CREATE TABLE addressBook (" +
                                      "id               INTEGER PRIMARY KEY AUTOINCREMENT," +
                                      "name             STRING," +
                                      "email            STRING," +
                                      "groupp           STRING," +
                                      "favorite         BOOLEAN," +
                                      "addressp         STRING," +
                                      "phonep           STRING)"));
                                      
        arrStatements.push(connection.createAsyncStatement("CREATE TABLE accounts (" + 
                                      "id               INTEGER PRIMARY KEY AUTOINCREMENT," +
                                      "indexx           INTEGER," +
                                      "name             STRING,"  +
                                      "email            STRING,"  +
                                      "replyTo          STRING,"  +
                                      "refresh          DOUBLE,"  +
                                      "deleteMode       STRING,"  +
                                      "color            STRING,"  +
                                      "subject          STRING,"  +
                                      "signature        STRING,"  +
                                      "isImap           BOOLEAN," +
                                      "pop3auth         INTEGER," +
                                      "pop3host         STRING,"  +
                                      "pop3port         INTEGER," +
                                      "pop3ssl          BOOLEAN," +
                                      "pop3login        STRING,"  +
                                      "smtpHost         STRING,"  +
                                      "smtpPort         INTEGER," +
                                      "smtpSsl          BOOLEAN," +
                                      "smtpLogin        STRING,"  +
                                      "smtpTls          BOOLEAN," +
                                      "smtpAuth         BOOLEAN)"));

        arrStatements.push(connection.createAsyncStatement("CREATE TABLE messages (" + 
                                      "id               INTEGER PRIMARY KEY AUTOINCREMENT," +
                                      "accountId        INTEGER," +
                                      "uid              STRING," +
                                      "fromm            STRING," + // "from" is reserved word
                                      "too              STRING," + // "to" is reserved word
                                      "cc               STRING," + 
                                      "bcc              STRING," + 
                                      "subject          STRING," + 
                                      "date             DATETIME," + 
                                      "size             DOUBLE," + 
                                      "charset          STRING," +
                                      "read             BOOLEAN," +
                                      "deleted          BOOLEAN," +
                                      "attachmentsDir   STRING," +
                                      "attachmentsCount INTEGER," +
                                      "html             STRING," +
                                      "folderId         INTEGER," +
                                      "partial          BOOLEAN," +
                                      "template         BOOLEAN," +
                                      "color            INTEGER DEFAULT 0," +
                                      "returnReceiptTo  STRING," +
                                      "replyTo          STRING," +
                                      "spam             BOOLEAN," +
                                      "replied          BOOLEAN," +
                                      "fwd              BOOLEAN)"));
    
        arrStatements.push(connection.createAsyncStatement("CREATE TABLE folders (" + 
                                      "id               INTEGER PRIMARY KEY AUTOINCREMENT," +
                                      "parentId         INTEGER DEFAULT 0," +
                                      "name             STRING," +
                                      "open             BOOLEAN)"));
    
        arrStatements.push(connection.createAsyncStatement("CREATE TABLE rules (" +
                                      "id               INTEGER PRIMARY KEY AUTOINCREMENT," +
                                      "filterId         INTEGER," +
                                      "property         STRING," +
                                      "negative         BOOLEAN," +
                                      "condition        STRING," +
                                      "param            STRING)"));
    
        arrStatements.push(connection.createAsyncStatement("CREATE TABLE actions (" +
                                      "id               INTEGER PRIMARY KEY AUTOINCREMENT," +
                                      "filterId         INTEGER," +
                                      "name             STRING," +
                                      "param            STRING)"));
    
        arrStatements.push(connection.createAsyncStatement("CREATE TABLE filters (" +
                                      "id               INTEGER PRIMARY KEY AUTOINCREMENT," +
                                      "indexx           INTEGER," +
                                      "name             STRING," +
                                      "type             INTEGER)"));
        
        connection.executeAsync(arrStatements, arrStatements.length,
          {
            handleResult: function(aResultSet) {
            },   
            handleError: function(aError) {
              console.error("SM.SimpleMailStorage_firstrun_step1.Error: " + aError.message);
            },
            handleCompletion: function(aReason) {
              if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
                console.error("SM.SimpleMailStorage_firstrun_step1: Query canceled or aborted!", aReason)
              else {
                //console.error('SM.SimpleMailStorage_firstrun_step1.done');//userok_log
                
                var arrStatements2 = [];

                arrStatements2.push(connection.createAsyncStatement("CREATE INDEX messages_accountId_uid ON messages (accountId, uid)"));
                arrStatements2.push(connection.createAsyncStatement("CREATE INDEX messages_deleted_folderId_id ON messages (deleted, folderId, id DESC)"));

                // Create default folders
                for (var i in simplemail.SimpleMailModel.SimpleMailFolder.DEFAULT_NAMES) {
                  var statement = connection.createAsyncStatement("INSERT INTO folders (name) VALUES (?1)");
                  statement.bindStringParameter(0, simplemail.SimpleMailModel.SimpleMailFolder.DEFAULT_NAMES[i]);
                  arrStatements2.push(statement);
                }

                // Create default fltr
                var statement = connection.createAsyncStatement("INSERT INTO filters (name, type) VALUES (?1, ?2)");
                statement.bindStringParameter(0, "default");
                statement.bindInt32Parameter(1, simplemail.SimpleMailModel.SimpleMailFilter.INBOX);
                arrStatements2.push(statement);

                var statement = connection.createAsyncStatement("INSERT INTO actions (filterId, name) VALUES (?1, ?2)");
                statement.bindInt32Parameter(0, 1);
                statement.bindStringParameter(1, "sound");
                arrStatements2.push(statement);

                connection.executeAsync(arrStatements2, arrStatements2.length,
                  {
                    handleResult: function(aResultSet) {
                    },   
                    handleError: function(aError) {
                      console.error("SM.SimpleMailStorage_firstrun_step2.Error" + aError.message);
                    },
                    handleCompletion: function(aReason) {
                      if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
                        console.error("SM.SimpleMailStorage_firstrun_step2_Query canceled or aborted!", aReason);
                      //else console.error('SM.SimpleMailStorage_firstrun_step2.done');//userok_log
                      // call callback done
                      if (callbackDone)
                        callbackDone();
                    }
                  }
                );
              }
            }
          }
        );
      } else {
        // call callback done
        if (callbackDone)
          callbackDone();
      }
    }
    
    // SQLite converts number-like strings to numbers, prevent this.
    var text = "text: ";

    function bindString(statement, id, value) {
      if (value && !isNaN(Number(value))) value = text + value;
      statement.bindStringParameter(id, value);
    }

    function getString(statement, id) {
      var value = statement.getString(id);
      return value && value.substr(0, text.length) == text ? value.substr(text.length) : value;
    }
   
    function StatementExecuteStep(st) {
      if (st)
        return st.executeStep();
    }
   
    function StatementExecute(st) {
      if (st)
        return st.execute();
    }
    
    // userok
    this.getAddressByEmail = function(stremail) {
      var taddrs = this.getAddresses();
      //console.error("SM.storage_getAddressByEmail", stremail, taddrs);//userok_log
      for (var i in taddrs) {
        if (taddrs[i].email == stremail)
          return taddrs[i];
      }      
    }
    
    // userok
    this.getAddressByName = function(objname) {
      var taddrs = this.getAddresses();
      //console.error("SM.storage_getAddressByName", objname, taddrs);//userok_log
      for (var i in taddrs) {
        if (taddrs[i].name == objname.name)
          return taddrs[i];
      }      
    }
    
    // userok: async
    this.addAddressList = function(callbackDone, list) {
      var addresses = simplemail.SimpleMailModel.SimpleMailAddress.parseList(list);
      for (var i in addresses) {
        if (!this.getAddressByEmail(addresses[i].email)) {
          this.AddressBook.push(addresses[i]);
          this.saveAddress(function(taddr) {
            if (callbackDone)
              callbackDone(taddr);
          }, addresses[i]); //userok: async
        }
      }
    }

    // userok: async
    this.saveAddress = function(callbackDone, aAddress) {
      //console.error("SM.storage_saveAddress", aAddress);//userok_log
      if (aAddress.id)
        var sql = "UPDATE addressBook SET name=:row_name, email=:row_mail, groupp=:row_grop, favorite=:row_favs, addressp=:row_addr, phonep=:row_phon WHERE id=:row_id"
      else
        var sql = "INSERT INTO addressBook (name, email, groupp, favorite, addressp, phonep) VALUES (:row_name, :row_mail, :row_grop, :row_favs, :row_addr, :row_phon)";

      var statement = connection.createAsyncStatement(sql);
      statement.params.row_mail = aAddress.email;
      statement.params.row_name = (aAddress.name)          ? aAddress.name     : "";
      statement.params.row_grop = (aAddress.group)         ? aAddress.group    : "";
      statement.params.row_addr = (aAddress.postaladdress) ? aAddress.postaladdress : "";
      statement.params.row_phon = (aAddress.phone)         ? aAddress.phone    : "";
      statement.params.row_favs = (aAddress.favorite)      ? aAddress.favorite : false;
      if (aAddress.id)
        statement.params.row_id = aAddress.id;

      statement.executeAsync({
        LAddress: aAddress,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage.saveAddrss.Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage.saveAddrss: Query canceled or aborted!", aReason)
          else {
            // get last rowid
            if (!this.LAddress.id)
              this.LAddress.id = connection.lastInsertRowID;
            // call callback done
            if (callbackDone)
              callbackDone(this.LAddress);
            // log
            //console.error("SM.storage.saveAddrss: OK", this.LAddress, connection.lastInsertRowID);//userok_log
          }
        }
      });
    }
  
    // userok: async
    this.dogetAddresses = function(callbackDone) {
      //console.error("SM.storage_dogetAddresses");//userok_log
      this.AddressBook  = [];
      var statement     = connection.createAsyncStatement("SELECT id, name, email, groupp, favorite, addressp, phonep FROM addressBook ORDER BY id DESC");
      statement.executeAsync({
        LAddressBook: this.AddressBook,
        handleResult: function(aResultSet) {
          for (var row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()) {
            var id     = row.getResultByName("id");
            var groupp = row.getResultByName("groupp");
            //if (groupp == "")
            //  groupp = 0;
            //if (!this.LAddressBook[groupp])
            //  this.LAddressBook[groupp] = [];
            //this.LAddressBook[groupp].push
            this.LAddressBook.push(new simplemail.SimpleMailModel.SimpleMailAddress(id, row.getResultByName("name"), row.getResultByName("email"), 
              groupp, row.getResultByName("favorite"), row.getResultByName("addressp"), row.getResultByName("phonep")));
          }
          //console.error("SM.storage_dogetAddresses_Result: ", this.LAddressBook, aResultSet);//userok_log
        },
        handleError: function(aError) {
          console.error("SM.storage_dogetAddresses_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_dogetAddresses_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(this.LAddressBook);
            // userok_log
            //console.error("SM.storage_dogetAddresses_OK", this);
          }
        }
      }); 
    }
   
    // userok
    this.getAddresses = function() {
      //console.error("SM.storage_getAddresses");//userok_log  
      return this.AddressBook;
    }
   
    // userok
    this.getAddressesByIds = function(arrIds) {
      var arrAdr = [];
      var taddrs = this.getAddresses();
      for (var i in taddrs) {
        if (arrIds.indexOf(taddrs[i].id.toString()) !== -1)
          arrAdr.push(taddrs[i]);
      }      
      //console.error("SM.getAddressesByIds", arrIds, arrAdr);//userok_log
      return arrAdr;
    }
 
    // userok: async 
    this.deleteAddress = function(callbackDone, ArrayAddressIDs) { 
      //console.error("SM.storage_deleteAddress_Array", ArrayAddressIDs);//userok_log
      
      var statement = connection.createAsyncStatement("DELETE FROM addressBook WHERE id IN (:row_ids)");
      var ids       = statement.newBindingParamsArray();
      for (var i in ArrayAddressIDs) {
        var bp = ids.newBindingParams();
        bp.bindByName("row_ids", ArrayAddressIDs[i]);
        ids.addParams(bp);
      }
      statement.bindParameters(ids);

      statement.executeAsync({
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_deleteAddress_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_deleteAddress_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone();
            //userok_log
            //console.error("SM.storage_deleteAddress_OK", ArrayAddressIDs);
          }
        }
      });
    }

    // userok: async
    this.doGetAccounts = function(callbackDone) {
      //console.error("SM.storage_doGetAccounts");//userok_log
          
      this.MailAccounts = [];
      var statement     = connection.createAsyncStatement("SELECT id, indexx, name, email, replyTo, refresh, deleteMode, color, subject, signature, " +
        "isImap, pop3auth, pop3host, pop3port, pop3ssl, pop3login, smtpHost, smtpPort, smtpSsl, smtpLogin, smtpTls, smtpAuth FROM accounts ORDER BY indexx");
      statement.executeAsync({
        LMailAccounts: this.MailAccounts,
        handleResult: function(aResultSet) {
          for (var row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()) {
            var taccount = new simplemail.SimpleMailModel.SimpleMailAccount(row.getResultByName("id"), row.getResultByName("indexx"), 
              row.getResultByName("name"), row.getResultByName("email"), row.getResultByName("replyTo"), row.getResultByName("refresh"), row.getResultByName("deleteMode"),
              row.getResultByName("color"), row.getResultByName("subject"), row.getResultByName("signature"), row.getResultByName("isImap"), row.getResultByName("pop3auth"), 
              row.getResultByName("pop3host"), row.getResultByName("pop3port"), row.getResultByName("pop3ssl"), row.getResultByName("pop3login"), row.getResultByName("smtpHost"), 
              row.getResultByName("smtpPort"), row.getResultByName("smtpSsl"), row.getResultByName("smtpLogin"), row.getResultByName("smtpTls"), row.getResultByName("smtpAuth"));
            // add
            this.LMailAccounts.push(taccount);
          }
          //console.error("SM.storage_doGetAccounts_Result: ", this.LMailAccounts, aResultSet);//userok_log
        },
        handleError: function(aError) {
          console.error("SM.storage_doGetAccounts_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_doGetAccounts_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(this.LMailAccounts);
            // userok_log
            //console.error("SM.storage_doGetAccounts_OK", this);
          }
        }
      }); 
    }
  
    // userok
    this.getAccounts = function() {
      //console.error("SM.storage_getAccounts");//userok_log
      return this.MailAccounts;
    }
  
    this.getAccount = function(id) {
      var taccounts = this.getAccounts();
      for (var i in taccounts) {
        if (taccounts[i].id == id) 
          return taccounts[i];
      }
    }
    
    // userok: async. Doesn't delete ALL acc messages (only deleted)
    this.deleteAccount = function(callbackDone, aAccount, index) {
      //console.error("SM.storage_deleteAccount", aAccount, index);//userok_log
      
      var statement = connection.createAsyncStatement("DELETE FROM messages WHERE deleted=1 AND accountId=:row_id");
      statement.bindByName("row_id", aAccount.id);
      statement.executeAsync({
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_deleteAccountMsg_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_deleteAccountMsg_Query canceled or aborted!", aReason);
          //else console.error("SM.storage_deleteAccountMsg_OK", aAccount, index);//userok_log
        }
      });
      
      var statement = connection.createAsyncStatement("DELETE FROM accounts WHERE id=:row_id");
      statement.bindByName("row_id", aAccount.id);
      statement.executeAsync({
        LAccount: aAccount,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_deleteAccount_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_deleteAccount_Query canceled or aborted!", aReason)
          else {
            simplemail.PasswordManager.removePassword(this.LAccount.id + "/pop3/");
            simplemail.PasswordManager.removePassword(this.LAccount.id + "/smtp/");    
            // call callback done
            if (callbackDone)
              callbackDone(this.LAccount, index);
            // userok_log
            //console.error("SM.storage_deleteAccount_OK", this.LAccount, index);
          }
        }
      });
    }
  
    // userok: async
    this.saveAccount = function(callbackDone, aAccount) {
      //console.error("SM.storage_saveAccount", aAccount);//userok_log
      
      if (aAccount.id)
        var sql = "UPDATE accounts SET indexx=:row_indx, name=:row_name, email=:row_mail, replyTo=:row_rply, refresh=:row_rfsh, deleteMode=:row_delm, color=:row_clor, subject=:row_subj, signature=:row_sign, isImap=:row_imap, pop3auth=:row_pauth, pop3host=:row_phost, pop3port=:row_pport, pop3ssl=:row_pssl, pop3login=:row_plogin, smtpHost=:row_shost, smtpPort=:row_sport, smtpSsl=:row_sssl, smtpLogin=:row_slogin, smtpTls=:row_stls, smtpAuth=:row_sauth WHERE id=:row_id"
      else
        var sql = "INSERT INTO accounts (indexx, name, email, replyTo, refresh, deleteMode, color, subject, signature, isImap, pop3auth, pop3host, pop3port, pop3ssl, pop3login, smtpHost, smtpPort, smtpSsl, smtpLogin, smtpTls, smtpAuth) VALUES (:row_indx, :row_name, :row_mail, :row_rply, :row_rfsh, :row_delm, :row_clor, :row_subj, :row_sign, :row_imap, :row_pauth, :row_phost, :row_pport, :row_pssl, :row_plogin, :row_shost, :row_sport, :row_sssl, :row_slogin, :row_stls, :row_sauth)";

      var statement = connection.createAsyncStatement(sql);
      statement.bindByName("row_indx",   aAccount.index);
      statement.bindByName("row_name",   aAccount.name);
      statement.bindByName("row_mail",   aAccount.email);
      statement.bindByName("row_rply",   aAccount.replyTo);
      statement.bindByName("row_rfsh",   aAccount.refresh);
      statement.bindByName("row_delm",   aAccount.deleteMode);
      statement.bindByName("row_clor",   aAccount.color);
      statement.bindByName("row_subj",   aAccount.subject);
      statement.bindByName("row_sign",   aAccount.signature);
      statement.bindByName("row_imap",   aAccount.pop3.isImap);
      statement.bindByName("row_pauth",  aAccount.pop3.auth);
      statement.bindByName("row_phost",  aAccount.pop3.host);
      statement.bindByName("row_pport",  aAccount.pop3.port);
      statement.bindByName("row_pssl",   aAccount.pop3.ssl);
      statement.bindByName("row_plogin", aAccount.pop3.login);
      statement.bindByName("row_shost",  aAccount.smtp.host);
      statement.bindByName("row_sport",  aAccount.smtp.port);
      statement.bindByName("row_sssl",   aAccount.smtp.ssl);
      statement.bindByName("row_slogin", aAccount.smtp.login);
      statement.bindByName("row_stls",   aAccount.smtp.tls);
      statement.bindByName("row_sauth",  aAccount.smtp.auth);
      if (aAccount.id) 
        statement.bindByName("row_id", aAccount.id);
      
      statement.executeAsync({
        LAccount: aAccount,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_saveAccount_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_saveAccount_Query canceled or aborted!", aReason)
          else {
            // get last rowid
            if (!this.LAccount.id)
              this.LAccount.id = connection.lastInsertRowID;
            // set passws
            if (this.LAccount.pop3.password != null)
              this.LAccount.pop3.setPassword(this.LAccount.pop3.password);
            if (this.LAccount.smtp.password != null)
              this.LAccount.smtp.setPassword(this.LAccount.smtp.password);
            // call callback done
            if (callbackDone)
              callbackDone(this.LAccount);
            // userok_log
            //console.error("SM.storage_saveAccount_OK", this.LAccount);
          }
        }
      });
    }
  
    // userok: async
    this.saveAccounts = function(taccounts) {
      for (var i = 0; i < taccounts.length; i++) {
        taccounts[i].index = i;
        this.saveAccount(0, taccounts[i]); // userok
      }
    }
  
    this.messageExists = function(accountId, uid) {
      var statement = connection.createStatement("SELECT uid FROM messages WHERE accountId=?1 AND uid=?2");
      try {
        statement.bindInt32Parameter(0, accountId);
        bindString(statement, 1, uid);
        return StatementExecuteStep(statement);
      } finally {
        statement.reset();
      }
    }
  
    // "Search" is performed in all folders.
    // Order by colors uses additional column noColor, so that no-color items appear at bottom
    function getMessages(condition, order) {
      var sql = "SELECT id, accountId, uid, fromm, too, cc, bcc, subject, date, size," +
                " charset, read, deleted, attachmentsDir, attachmentsCount, folderId," +
                " partial, template, color = 0 AS noColor, color, returnReceiptTo, replyTo, spam, replied, fwd" +
                " FROM messages WHERE deleted = 0 AND " + condition + " ORDER BY " + (order || "id DESC");
			var statement = connection.createStatement(sql);
			
      try {
        var messages = [];
        while (StatementExecuteStep(statement)) {
          var id = statement.getInt32(0);
          messages.push(new simplemail.SimpleMailModel.SimpleMailMessage(
            id,
            statement.getInt32(1),
            getString(statement, 2),
            getString(statement, 3),
            getString(statement, 4),
            getString(statement, 5),
            getString(statement, 6),
            getString(statement, 7),
            new Date(statement.getInt64(8)),
            statement.getDouble(9),
            getString(statement, 10),
            statement.getInt32(11),
            statement.getInt32(12),
            getString(statement, 13),
            statement.getInt32(14),
            null,
            statement.getInt32(15),
            statement.getInt32(16),
            statement.getInt32(17),
            statement.getInt32(19),
            getString(statement, 20),
            getString(statement, 21),
            statement.getInt32(22),
            statement.getInt32(23),
            statement.getInt32(24)
          ));
        }
        return messages;
      }
      finally {
        statement.reset();
      }
    }
  
    this.getAccountMessages = function(accountId) {
      return getMessages("accountId=" + accountId);
    }
  
    this.getFolderMessages = function(folderId, order) {
      return getMessages("folderId=" + folderId, order);
    }
  
    this.getSearchMessages = function(search, order) {
      var condition = "(subject LIKE '%"
        + search + "%' OR html LIKE '%"
        + search + "%' OR fromm LIKE '%"
        + search + "%' OR too LIKE '%"
        + search + "%' OR cc LIKE '%"
        + search + "%' OR bcc LIKE '%"
        + search + "%')";
      return getMessages(condition, order);
    }
  
    this.saveMessage = function(message, noSourceUpdate) {
      if (message.deleted) {
        // Do not really delete message, keep its uid in DB
        // So that it's not downloaded from server again
        simplemail.SimpleMailFile.deleteAttachments(message.attachmentsDir);
  
        message.from            = null;
        message.to              = null;
        message.cc              = null;
        message.bcc             = null;
        message.subject         = null;
        message.date            = null;
        message.size            = null;
        message.charset         = null;
        message.read            = null;
        message.attachmentsDir  = null;
        message.attachmentsCount= null;
        message.html            = null;
        message.folderId        = null;
        message.partial         = null;
        message.template        = null;
        message.color           = null;
        message.returnReceiptTo = null;
        message.replyTo         = null;
        message.spam            = null;
        message.replied         = null;
        message.fwd             = null;
      } else if (!noSourceUpdate) {
        simplemail.SimpleMailFile.saveAttachment(message.attachmentsDir, simplemail.SimpleMailFile.MESSAGE_SOURCE, message.source || message.toString());
      }

      if (message.id)
        var sql = "UPDATE messages SET accountId=?1, uid=?2, fromm=?3, too=?4, cc=?5, bcc=?6, subject=?7, date=?8, size=?9, charset=?10," +
                  "read=?11, deleted=?12, attachmentsDir=?13, attachmentsCount=?14, html=?15, folderId=?16, partial=?17, template=?18, color=?19," +
                  "returnReceiptTo=?20, replyTo=?21, spam=?22, replied=?23, fwd=?24 WHERE id=?25"
      else
        var sql = "INSERT INTO messages (accountId, uid, fromm, too, cc, bcc, subject, date, size, charset, read, deleted, attachmentsDir," +
                  "attachmentsCount, html, folderId, partial, template, color, returnReceiptTo, replyTo, spam, replied, fwd) VALUES (?1, ?2, ?3, ?4, ?5, ?6, ?7," +
                  "?8, ?9, ?10, ?11, ?12, ?13, ?14, ?15, ?16, ?17, ?18, ?19, ?20, ?21, ?22, ?23, ?24)";

			var statement = connection.createStatement(sql);
      statement.bindInt32Parameter(0, message.accountId);
      bindString(statement, 1, message.uid);
      bindString(statement, 2, message.from);
      bindString(statement, 3, message.to);
      bindString(statement, 4, message.cc);
      bindString(statement, 5, message.bcc);
      bindString(statement, 6, message.subject);
      statement.bindInt64Parameter(7, message.date);
      statement.bindDoubleParameter(8, !message.deleted && message.getSize());
      bindString(statement, 9, message.charset);
      statement.bindInt32Parameter(10, message.read);
      statement.bindInt32Parameter(11, message.deleted);
      bindString(statement, 12, message.attachmentsDir);
      statement.bindInt32Parameter(13, message.attachmentsCount);
      bindString(statement, 14, message.html);
      statement.bindInt32Parameter(15, message.folderId);
      statement.bindInt32Parameter(16, message.partial);
      statement.bindInt32Parameter(17, message.template);
      statement.bindInt32Parameter(18, message.color);
      bindString(statement, 19, message.returnReceiptTo);
      bindString(statement, 20, message.replyTo);
      statement.bindInt32Parameter(21, message.spam);
      statement.bindInt32Parameter(22, message.replied);
      statement.bindInt32Parameter(23, message.fwd);
      if (message.id) 
        statement.bindInt32Parameter(24, message.id);
      StatementExecute(statement);

      if (!message.id) {
        message.id = connection.lastInsertRowID; // userok
      //userok  console.error("SM.AAAA", connection.lastInsertRowID, statement);//userok_log
      //userok  var statement = connection.createStatement("SELECT last_insert_rowid() FROM messages");
      //userok  try {
      //userok    if (StatementExecuteStep(statement)) {
      //userok      message.id = statement.getInt32(0);
      //userok      console.error("SM.ZZZZ", message.id);//userok_log
      //userok    }
      //userok  } finally {
      //userok    statement.reset();
      //userok  }
      }
    }
    
    // userok: async
    this.updateMessage = function(callbackDone, message, messageSize) {
      //console.error("SM.storage_updateMessage", message, messageSize);//userok_log
      
      if (message.id)
        var sql = "UPDATE messages SET accountId=:row_accid, uid=:row_uid, fromm=:row_from, too=:row_to, cc=:row_cc, bcc=:row_bcc, subject=:row_subj, date=:row_date, size=:row_size, charset=:row_chrset, read=:row_read, deleted=:row_del, attachmentsDir=:row_adir, attachmentsCount=:row_acount, html=:row_html, folderId=:row_fid, partial=:row_part, template=:row_tmpl, color=:row_clor, returnReceiptTo=:row_retto, replyTo=:row_rply, spam=:row_spam, replied=:row_repl, fwd=:row_fwd WHERE id=:row_id"
      else
        var sql = "INSERT INTO messages (accountId, uid, fromm, too, cc, bcc, subject, date, size, charset, read, deleted, attachmentsDir, attachmentsCount, html, folderId, partial, template, color, returnReceiptTo, replyTo, spam, replied, fwd) VALUES (:row_accid, :row_uid, :row_from, :row_to, :row_cc, :row_bcc, :row_subj, :row_date, :row_size, :row_chrset, :row_read, :row_del, :row_adir, :row_acount, :row_html, :row_fid, :row_part, :row_tmpl, :row_clor, :row_retto, :row_rply, :row_spam, :row_repl, :row_fwd)";

      var statement = connection.createAsyncStatement(sql);
      statement.bindByName("row_accid", message.accountId);
      statement.bindByName("row_uid", message.uid);
      statement.bindByName("row_from", message.from);
      statement.bindByName("row_to", message.to);
      statement.bindByName("row_cc", message.cc);
      statement.bindByName("row_bcc", message.bcc);
      statement.bindByName("row_subj", message.subject);
      statement.bindByName("row_date", message.date.getTime()); //bindInt64Parameter
      statement.bindByName("row_size", !message.deleted && message.getSize());
      statement.bindByName("row_chrset", message.charset);
      statement.bindByName("row_read", message.read);
      statement.bindByName("row_del", message.deleted);
      statement.bindByName("row_adir", message.attachmentsDir);
      statement.bindByName("row_acount", message.attachmentsCount);
      statement.bindByName("row_html", message.html);
      statement.bindByName("row_fid", message.folderId);
      statement.bindByName("row_part", message.partial);
      statement.bindByName("row_tmpl", message.template);
      statement.bindByName("row_clor", message.color);
      statement.bindByName("row_retto", message.returnReceiptTo);
      statement.bindByName("row_rply", message.replyTo);
      statement.bindByName("row_spam", message.spam);
      statement.bindByName("row_repl", message.replied);
      statement.bindByName("row_fwd", message.fwd);
      if (message.id) 
        statement.bindByName("row_id", message.id);
      
      statement.executeAsync({
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_updateMessage_Error: ", aError.message, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_updateMessage_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(message, messageSize);
            // userok_log
            //console.error("SM.storage_updateMessage_OK", message, messageSize);
          }
        }
      });
    }
    
    // userok: async
    this.deleteMessage = function(callbackDone, message) {
      if (message.uid && this.getAccount(message.accountId)) {
        message.deleted = true;
        this.saveMessage(message);
        // call callback done
        if (callbackDone)
          callbackDone(message);
      } else {
        simplemail.SimpleMailFile.deleteAttachments(message.attachmentsDir);
        
        var statement = connection.createAsyncStatement("DELETE FROM messages WHERE id=:row_id");
        statement.bindByName("row_id", message.id);
        statement.executeAsync({
          handleResult: function(aResultSet) {
          },
          handleError: function(aError) {
            console.error("SM.storage_deleteMessage_Error: ", aError.message, aError, connection);
          },
          handleCompletion: function(aReason) {
            if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
              console.error("SM.storage_deleteMessage_Query canceled or aborted!", aReason)
            else {
              // call callback done
              if (callbackDone)
                callbackDone(message);
              // userok_log
              //console.error("SM.storage_deleteMessage_OK", message);
            }
          }
        });
      }
    }
  
    this.getMessage = function(id) {
      var sql = "SELECT id, accountId, uid, fromm, too, cc, bcc, subject, date, size, " +
                "charset, read, deleted, attachmentsDir, attachmentsCount, html, folderId," +
                "partial, template, color, returnReceiptTo, replyTo, spam, replied, fwd FROM messages WHERE id=?1";      
      var statement = connection.createStatement(sql);
      try {
        statement.bindInt32Parameter(0, id);
        if (StatementExecuteStep(statement)) 
          return new simplemail.SimpleMailModel.SimpleMailMessage(
          id,
          statement.getInt32(1),
          getString(statement, 2),
          getString(statement, 3),
          getString(statement, 4),
          getString(statement, 5),
          getString(statement, 6),
          getString(statement, 7),
          new Date(statement.getInt64(8)),
          statement.getDouble(9),
          getString(statement, 10),
          statement.getInt32(11),
          statement.getInt32(12),
          getString(statement, 13),
          statement.getInt32(14),
          getString(statement, 15),
          statement.getInt32(16),
          statement.getInt32(17),
          statement.getInt32(18),
          statement.getInt32(19),
          getString(statement, 20),
          getString(statement, 21),
          statement.getInt32(22),
          statement.getInt32(23),
          statement.getInt32(24)
        );
      }
      finally {
        statement.reset();
      }
    }

    this.saveMessageState = function(message) {
      var sql = "UPDATE messages SET read=?1, folderId=?2, color=?3, returnReceiptTo=?4, spam=?5, replied=?6, fwd=?7 WHERE id=?8";
      var statement = connection.createStatement(sql);
      statement.bindInt32Parameter(0, message.read);
      statement.bindInt32Parameter(1, message.folderId);
      statement.bindInt32Parameter(2, message.color);
      bindString(statement, 3, message.returnReceiptTo);
      statement.bindInt32Parameter(4, message.spam);
      statement.bindInt32Parameter(5, message.replied);
      statement.bindInt32Parameter(6, message.fwd);
      statement.bindInt32Parameter(7, message.id);
      StatementExecute(statement);
    }
  
    // userok: async
    this.getUnreadCount = function(callbackDone) {
      //console.error("SM.storage_getUnreadCount");//userok_log
      var statement = connection.createAsyncStatement("SELECT COUNT(id) FROM messages WHERE deleted=0 AND read=0 AND folderId!=:row_fid");
      statement.bindByName("row_fid", simplemail.SimpleMailModel.SimpleMailFolder.TRASH);
      statement.executeAsync({
        LCount: 0,
        handleResult: function(aResultSet) {
          var row = aResultSet.getNextRow();
          if (row)
            this.LCount = row.getResultByIndex(0); 
          //console.error("SM.storage_getUnreadCount_Result", this.LCount);//userok_log
        },
        handleError: function(aError) {
          console.error("SM.storage_getUnreadCount_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_getUnreadCount_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(this.LCount);
            // userok_log
            //console.error("SM.storage_getUnreadCount_OK", this.LCount);
          }
        }
      });
    }
  
    // userok: async (Folders grouped by parentId)
    this.dogetFolders = function(callbackDone) {     
      //console.error("SM.storage_dogetFolders");//userok_log
      this.MailFolders  = [];
      var statement     = connection.createAsyncStatement("SELECT id, parentId, name, open FROM folders");
      statement.executeAsync({
        LMailFolders: this.MailFolders,
        handleResult: function(aResultSet) {
          for (var row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()) {
            var id       = row.getResultByName("id");
            var parentId = row.getResultByName("parentId");
            if (!this.LMailFolders[parentId])
              this.LMailFolders[parentId] = [];

            this.LMailFolders[parentId].push(new simplemail.SimpleMailModel.SimpleMailFolder(id, parentId, row.getResultByName("name"), row.getResultByName("open")));
          }
          //console.error("SM.storage_dogetFolders_Result: ", this.LMailFolders, aResultSet);//userok_log
        },
        handleError: function(aError) {
          console.error("SM.storage_dogetFolders_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_dogetFolders_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(this.LMailFolders);
            // userok_log
            //console.error("SM.storage_dogetFolders_OK", this);
          }
        }
      }); 
    }  
    
    // userok
    this.getFolders = function() {
      //console.error("SM.storage_getFolders", this);//userok_log
      return this.MailFolders;
    }

    this.getFolder = function(id) {
      var tfolders = this.getFolders();
      for (var i in tfolders) {
        var children = tfolders[i];
        for (var j in children) {
          if (children[j].id == id) 
            return children[j];
        }
      }
    }
  
    // userok: async (for archive.js only)
    this.getFoldersForArchive = function(callbackDone) {
      //console.error("SM.storage_getFoldersForArchive", this);//userok_log
      
      var foldersNames = [];
      var statement    = connection.createAsyncStatement("SELECT id, parentId, name, open FROM folders");
      statement.executeAsync({
        handleResult: function(aResultSet) {
          for (var row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow())
            foldersNames.push(row.getResultByName("name"));
        },
        handleError: function(aError) {
          console.error("SM.storage_getFoldersForArchive_Error: ", aError.message, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_getFoldersForArchive_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(foldersNames);
            // userok_log
            //console.error("SM.storage_getFoldersForArchive_OK", foldersNames);
          }
        }
      });
    }
    
    // Unread counts keyed by folderId 
    this.updateFolderCounts = function() {
      var tfolders  = this.getFolders();
      var counts    = [];
      var statement = connection.createStatement("SELECT folderId, COUNT(id), sum(size), sum(1-read) FROM messages WHERE deleted = 0 GROUP BY folderId");
      try {
        while (StatementExecuteStep(statement)) {
          var folderId = statement.getInt32(0);
          counts[folderId] = {
            total:  statement.getInt32(1),
            size:   statement.getInt32(2),
            unread: statement.getInt32(3)
          };
        }
      } finally {
        statement.reset();
      }
  
      function calculateChildUnread(folderId, aCounts) {
        var fcount = aCounts[folderId];
        if (!fcount) 
          fcount = aCounts[folderId] = {};
  
        fcount.unread      |= 0;
        fcount.childUnread |= 0;
        
        var children = tfolders[folderId];
        for(var i in children) {
          var child = children[i];
          fcount.childUnread += calculateChildUnread(child.id, aCounts);
        }
        
        return fcount.unread + fcount.childUnread;
      }
  
      calculateChildUnread(0, counts);
  
      //console.error("SM.storage_updateFolderCounts", counts);//userok_log
      return counts;
    }
  
    // userok: async
    this.saveFolder = function(callbackDone, aFolder) {
      //console.error("SM.storage_saveFolder", aFolder);//userok_log
      
      if (aFolder.id)
        var sql = "UPDATE folders SET parentId=:row_pid, name=:row_nme, open=:row_opn WHERE id=:row_id"
      else
        var sql = "INSERT INTO folders (parentId, name, open) VALUES (:row_pid, :row_nme, :row_opn)";
      
      var statement = connection.createAsyncStatement(sql);
      statement.bindByName("row_pid", aFolder.parentId);
      statement.bindByName("row_nme", aFolder.name);
      statement.bindByName("row_opn", aFolder.open);
      if (aFolder.id) 
        statement.bindByName("row_id", aFolder.id);

      statement.executeAsync({
        LFolder: aFolder,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_saveFolder_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_saveFolder_Query canceled or aborted!", aReason)
          else {
            // get last rowid
            if (!this.LFolder.id)
              this.LFolder.id = connection.lastInsertRowID;             
            // call callback done
            if (callbackDone)
              callbackDone(this.LFolder);            
            // userok_log
            //console.error("SM_storage_saveFolder_OK", connection.lastInsertRowID, this.LFolder);
          }
        }
      }); 
    }
  
    // userok
    this.scanFolder = function(aFolder, arrChild, childrenOnly) {
      if (!childrenOnly)
        arrChild.push(aFolder);
      
      var children = this.getFolders()[aFolder.id];
      for (var i in children)
        this.scanFolder(children[i], arrChild, false);
    }
    
    // userok: async
    this.deleteFolder = function(callbackDone, aFolder, childrenOnly) {
      // Recursively delete child folders
      var arrChild = [];
      this.scanFolder(aFolder, arrChild, childrenOnly);
      //console.error("SM.storage_deleteFolder", aFolder, childrenOnly, arrChild);//userok_log
      if (!arrChild.length) {
        // call callback done - userok this need?
        if (callbackDone)
          callbackDone(aFolder, childrenOnly);
        return;
      }
      
      var statement = connection.createAsyncStatement("DELETE FROM folders WHERE id IN (:row_ids)");
      var ids       = statement.newBindingParamsArray();
      for (var i in arrChild) {
        var bp = ids.newBindingParams();
        bp.bindByName("row_ids", arrChild[i].id);
        ids.addParams(bp);
      }
      statement.bindParameters(ids);

      statement.executeAsync({
        LFolder: aFolder,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_deleteFolder_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_deleteFolder_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(this.LFolder, childrenOnly);
            //userok_log
            //console.error("SM.storage_deleteFolder_OK", this.LFolder, childrenOnly, arrChild);
          }
        }
      });
    }
    
    // userok: async (for spam.js)
    this.deleteFilterRule = function(callbackDone, filterId, ruleId) {
      //console.error("SM.storage_deleteFilterRule", filterId, ruleId);//userok_log      
      
      var statement = connection.createAsyncStatement("DELETE FROM rules WHERE filterId=:row_fid AND id=:row_id");
      statement.bindByName("row_fid", filterId);
      statement.bindByName("row_id",  ruleId);

      statement.executeAsync({
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_deleteFilterRule_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_deleteFilterRule_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(filterId, ruleId);            
            // userok_log
            //console.error("SM.storage_deleteFilterRule_OK", filterId, ruleId);
          }
        }
      });
    }
    
    // userok: async (for spam.js)
    this.deleteFilterAction = function(callbackDone, filterId, actionId) {
      //console.error("SM.storage_deleteFilterAction", filterId, actionId);//userok_log

      var statement = connection.createAsyncStatement("DELETE FROM actions WHERE filterId=:row_fid AND id=:row_id");
      statement.bindByName("row_fid", filterId);
      statement.bindByName("row_id",  actionId);

      statement.executeAsync({
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_deleteFilterAction_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_deleteFilterAction_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(filterId, actionId);            
            // userok_log
            //console.error("SM.storage_deleteFilterAction_OK", filterId, ruleId);
          }
        }
      });
    }
  
    // userok: async
    function getRules(callbackDone, aFilter) {
      //console.error("SM.storage_getRules", aFilter);//userok_log
      var statement = connection.createAsyncStatement("SELECT id, filterId, property, negative, condition, param FROM rules WHERE filterId=:row_fid");
      statement.bindByName("row_fid", aFilter.id);
      statement.executeAsync({
        LFilter: aFilter,
        handleResult: function(aResultSet) {
          this.LFilter.rules = [];
          for (var row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()) {
            this.LFilter.rules.push(new simplemail.SimpleMailModel.SimpleMailRule(
              row.getResultByName("id"), row.getResultByName("filterId"), 
              row.getResultByName("property"), row.getResultByName("negative"), 
              row.getResultByName("condition"), row.getResultByName("param")
            ));
          }
          //console.error("SM.storage_getRules_Result", this);//userok_log
        },
        handleError: function(aError) {
          console.error("SM.storage_getRules_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_getRules_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(this.LFilter);
            // userok_log
            //console.error("SM.storage_getRules_OK", this);
          }
        }
      });
    }
    
    // userok: async
    function saveRule(callbackDone, aRule) {
      //console.error("SM.storage_saveRule", aRule);//userok      
      
      if (aRule.id)
        var sql = "UPDATE rules SET filterId=:row_fid, property=:row_prp, negative=:row_neg, condition=:row_cnd, param=:row_par WHERE id=:row_id"
      else
        var sql = "INSERT INTO rules (filterId, property, negative, condition, param) VALUES (:row_fid, :row_prp, :row_neg, :row_cnd, :row_par)";
      
      var statement = connection.createAsyncStatement(sql);
      statement.params.row_fid = aRule.filterId;
      statement.params.row_prp = aRule.property;
      statement.params.row_neg = aRule.not;
      statement.params.row_cnd = aRule.condition;
      statement.params.row_par = aRule.param;
      if (aRule.id) 
        statement.params.row_id = aRule.id;

      statement.executeAsync({
        LRule: aRule,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_saveRule_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_saveRule_Query canceled or aborted!", aReason)
          else {
            // get last rowid
            if (!this.LRule.id)
              this.LRule.id = connection.lastInsertRowID; 
            // call callback done
            if (callbackDone)
              callbackDone(this.LRule);            
            // userok_log
            //console.error("SM.storage_saveRule_OK", connection.lastInsertRowID, this.LRule);
          }
        }
      });
    }
  
    // userok: async
    function saveRules(aFilter) {
      var row_ids = [];
      for (var i in aFilter.rules) {
        if (aFilter.rules[i].id)
          row_ids.push(aFilter.rules[i].id);
      }
      //console.error("SM.storage_saveRules", aFilter, row_ids);//userok_log

      //var statement = connection.createAsyncStatement("DELETE FROM rules WHERE filterId=:row_fid AND id NOT IN (" + row_ids.join(",") + ")");
      var sql = "DELETE FROM rules WHERE filterId=:row_fid AND id NOT IN (";
      sql += row_ids.join(",");
      sql += ")";
      var statement = connection.createAsyncStatement(sql);

      statement.bindByName("row_fid", aFilter.id);
      statement.executeAsync({
        LFilter: aFilter,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_saveRules_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_saveRules_Query canceled or aborted!", aReason)
          else {
            for (var i in this.LFilter.rules) {
              this.LFilter.rules[i].filterId = this.LFilter.id;
              saveRule(0, this.LFilter.rules[i]);
            }
            // userok_log
            //console.error("SM.storage_saveRules_OK", this.LFilter.rules);
          }
        }
      });
    }
    
    // userok: async
    function getActions(callbackDone, aFilter) {
      //console.error("SM.storage_getActions", aFilter);//userok_log
      var statement = connection.createAsyncStatement("SELECT id, filterId, name, param FROM actions WHERE filterId=:row_fid");
      statement.bindByName("row_fid", aFilter.id);
      statement.executeAsync({
        LFilter: aFilter,
        handleResult: function(aResultSet) {
          this.LFilter.actions = [];
          for (var row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()) {
            this.LFilter.actions.push(new simplemail.SimpleMailModel.SimpleMailAction(
              row.getResultByName("id"), row.getResultByName("filterId"), row.getResultByName("name"), row.getResultByName("param")
            ));
          }
          //console.error("SM.storage_getActions_Result: ", this.LFilter);//userok_log
        },
        handleError: function(aError) {
          console.error("SM.storage_getActions_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_getActions_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(this.LFilter);
            // userok_log
            //console.error("SM.storage_getActions_OK", this.LFilter);
          }
        }
      });
    }
  
    // userok: async
    function saveAction(callbackDone, aAction) {
      //console.log("SM.storage_saveAction", aAction);//userok_log      
      
      if (aAction.id)
        var sql = "UPDATE actions SET filterId=:row_fid, name=:row_nme, param=:row_par WHERE id=:row_id"
      else
        var sql = "INSERT INTO actions (filterId, name, param) VALUES (:row_fid, :row_nme, :row_par)";

      var statement = connection.createAsyncStatement(sql);
      statement.bindByName("row_fid", aAction.filterId);
      statement.bindByName("row_nme", aAction.name);
      statement.bindByName("row_par", aAction.param);
      if (aAction.id) 
        statement.bindByName("row_id", aAction.id);
      
      statement.executeAsync({
        LAction: aAction,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_saveAction_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_saveAction_Query canceled or aborted!", aReason)
          else {
            // get last rowid
            if (!this.LAction.id)
              this.LAction.id = connection.lastInsertRowID; 
            // call callback done
            if (callbackDone)
              callbackDone(this.LAction);            
            // userok_log
            //console.error("SM.storage_saveAction_OK", connection.lastInsertRowID, this.LAction);
          }
        }
      });
    }
       
    // userok: async
    function saveActions(aFilter) { 
      var row_ids = [];
      for (var i in aFilter.actions) {
        if (aFilter.actions[i].id) {
          row_ids.push(aFilter.actions[i].id);
        }
      }
      //console.error("SM.storage_saveActions", aFilter, row_ids);//userok_log

      //var statement = connection.createAsyncStatement("DELETE FROM actions WHERE filterId=:row_fid AND id NOT IN (" + row_ids.join(",") + ")");
      var sql = "DELETE FROM actions WHERE filterId=:row_fid AND id NOT IN (";
      sql += row_ids.join(",");
      sql += ")";
      var statement = connection.createAsyncStatement(sql);
      
      statement.bindByName("row_fid", aFilter.id);
      statement.executeAsync({
        LFilter: aFilter,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_saveActions_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_saveActions_Query canceled or aborted!", aReason)
          else {
            for (var i in this.LFilter.actions) {
              this.LFilter.actions[i].filterId = this.LFilter.id;
              saveAction(0, this.LFilter.actions[i]);
            }
            // userok_log
            //console.error("SM.storage_saveActions_OK", this.LFilter.actions);
          }
        }
      });
    }
  
    // userok: async (callbackDone possible called before rules\actions are returned)
    this.doGetFilters = function(callbackDone) {
      //console.error("SM.storage_doGetFilters");//userok_log
          
      this.MailFilters = [];
      var statement    = connection.createAsyncStatement("SELECT id, indexx, name, type FROM filters ORDER BY indexx");
      statement.executeAsync({
        LMailFilters: this.MailFilters,
        handleResult: function(aResultSet) {
          for (var row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()) {
            var tfilter = 
              new simplemail.SimpleMailModel.SimpleMailFilter(row.getResultByName("id"), row.getResultByName("indexx"), row.getResultByName("name"), row.getResultByName("type"), [], []);
            // add 
            this.LMailFilters.push(tfilter);
            // get actions, rules async
            getRules(0, tfilter);
            getActions(0, tfilter);
          }
          //console.error("SM.storage_doGetFilters_Result: ", this.LMailFilters);//userok_log
        },
        handleError: function(aError) {
          console.error("SM.storage_doGetFilters_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_doGetFilters_Query canceled or aborted!", aReason)
          else {
            // call callback done
            if (callbackDone)
              callbackDone(this.LMailFilters);
            // userok_log
            //console.error("SM.storage_doGetFilters_OK", this);
          }
        }
      }); 
    }
    
    // userok
    this.getFilters = function() {
      //console.error("SM.storage_getFilters", this);//userok_log      
      return this.MailFilters;
    }
  
    // userok: async
    this.saveFilter = function(callbackDone, aFilter) {
      //console.error("SM.storage_saveFilter", aFilter);//userok_log
      
      if (aFilter.id)
        var sql = "UPDATE filters SET indexx=:row_indx, name=:row_name, type=:row_type WHERE id=:row_id"
      else
        var sql = "INSERT INTO filters (indexx, name, type) VALUES (:row_indx, :row_name, :row_type)";

      var statement = connection.createAsyncStatement(sql);
      statement.bindByName("row_indx", aFilter.index);
      statement.bindByName("row_name", aFilter.name);
      statement.bindByName("row_type", aFilter.type);
      if (aFilter.id) 
        statement.bindByName("row_id", aFilter.id);
      
      statement.executeAsync({
        LFilter: aFilter,
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_saveFilter_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_saveFilter_Query canceled or aborted!", aReason)
          else {
            // get last rowid
            if (!this.LFilter.id)
              this.LFilter.id = connection.lastInsertRowID;
            // save rules, actions, clear filtercache
            saveRules(this.LFilter);
            saveActions(this.LFilter);
            // call callback done
            if (callbackDone)
              callbackDone(this.LFilter);
            // userok_log
            //console.error("SM.storage_saveFilter_OK", this.LFilter);
          }
        }
      });
    }
  
    // userok: async
    this.saveFilters = function(tfilters) {
      for (var i = 0; i < tfilters.length; i++) {
        tfilters[i].index = i;
        this.saveFilter(0, tfilters[i]); // userok: async
      }
    }
  
    // userok: async
    this.deleteFilter = function(callbackDone, aFilter, filterIndex) {
      //console.error("SM.storage_deleteFilter", aFilter, filterIndex);//userok_log
      var arrStatements = [];
      
      var statement = connection.createAsyncStatement("DELETE FROM rules WHERE filterId=:row_fid");
      statement.bindByName("row_fid", aFilter.id);
      arrStatements.push(statement);
  
      var statement = connection.createAsyncStatement("DELETE FROM actions WHERE filterId=:row_fid");
      statement.bindByName("row_fid", aFilter.id);
      arrStatements.push(statement);
  
      var statement = connection.createAsyncStatement("DELETE FROM filters WHERE id=:row_fid");
      statement.bindByName("row_fid", aFilter.id);
      arrStatements.push(statement);
  
      connection.executeAsync(arrStatements, arrStatements.length, {
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_deleteFilter.Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_deleteFilter_Query canceled or aborted!", aReason)
          else { 
            // call callback done
            if (callbackDone)
              callbackDone(aFilter, filterIndex);
            // userok_log
            //console.error("SM.storage_deleteFilter_OK", aFilter, filterIndex);
          }
        }
      });
    }
    
    // userok: async
    this.doCleanDataBase = function() {
      //console.error("SM.storage_docleanDataBase", this);//userok_log
      var statement = connection.createAsyncStatement("VACUUM"); 
      statement.executeAsync({
        handleResult: function(aResultSet) {
        },
        handleError: function(aError) {
          console.error("SM.storage_docleanDataBase_Error: ", aError.message, aError, connection);
        },
        handleCompletion: function(aReason) {
          if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
            console.error("SM.storage_docleanDataBase_Query canceled or aborted!", aReason);
          //else console.error("SM.storage_docleanDataBase_OK", connection);//userok_log
        }
      });
    }
  
  }

  return pub;
}();