// Code taken from: http://developer.mozilla.org/en/docs/Chrome:_Command_Line

var   Cc = Components.classes;
var   Ci = Components.interfaces;

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
Components.utils.import("resource://gre/modules/Services.jsm");

var   CHROME_URI = "chrome://simplemail/content/main/main.xul";

function openWindow(aChromeURISpec) {
  var wnd = Services.ww.openWindow(null, "chrome://browser/content/browser.xul", null, null, null);
  wnd.addEventListener("load", openSimpleMail, false);

  function openSimpleMail() {
    wnd.setTimeout(wnd.loadURI(CHROME_URI), 100);
  }
}

// Command Line Handler
function CommandLineHandler() {
};

CommandLineHandler.prototype = {
  classDescription: "myAppHandler",
  classID: Components.ID('{97F3D658-4931-11DD-A820-938C56D89593}'),
  contractID: "@mozilla.org/commandlinehandler/general-startup;1?type=simplemail",
  _xpcom_categories: [{
    category: "command-line-handler",
    entry: "m-simplemail"
  }],

  QueryInterface: XPCOMUtils.generateQI([
    Ci.nsICommandLineHandler
  ]),

  /* nsICommandLineHandler */
  handle : function clh_handle(cmdLine) {
    if (cmdLine.handleFlag("simplemail", false)) {
      openWindow(CHROME_URI);
      cmdLine.preventDefault = true;
    }
  },

  helpInfo : "  -simplemail          Open My Application\n" +
             "                       wrapping this description\n"
};

var NSGetFactory = XPCOMUtils.generateNSGetFactory([CommandLineHandler]);
